/**
   WhoWhatWhere.java

   Copyright (C) 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package matrix;

import matrix.vrml.*;
import java.io.*;
/**
 *  This class builds and parses messages listing user's, object's and room names and number of room occupants.
 *  
 *
 *  @version 1.1
 *  @see matrix.deck.FrontEnd and its inner class WWWBuffer.
 */
public class WhoWhatWhere extends Message {
  final public static int WHO     = 100,
                          WHAT     = 300,
                          WHERE     = 400,
                          WHTUPD    = 350,
                          WHRUPD	= 450,
                          EVENTS     = 500,
                          TYPE = 4;

  public int command;
  public String name;
  public String [] wwwe;

  public WhoWhatWhere(){
  }

  public WhoWhatWhere( int command, String name, String [] arg ) throws IOException {
   if( name == null || arg == null )
      throw new IOException("Data items are null");
     this.command = command;
    this.name = name;
    wwwe = arg;
  }

  public WhoWhatWhere( DataInputStream in ) throws IOException {
    read( in );
  }

  public int getType(){
    return TYPE;
  }

  public synchronized void read( DataInputStream in ) throws IOException {
    command = in.readInt();
    name = in.readUTF();
  wwwe = new String[in.readInt()];
    for (int i = 0; i < wwwe.length; i++) {
      wwwe[i] = in.readUTF();
    }
  }

  public synchronized void write( DataOutputStream out ) throws IOException {
   if( name == null || wwwe == null )
      throw new IOException("Data items are null");
    out.writeInt( command );
    out.writeUTF( name );
	out.writeInt(wwwe.length);
  for (int i = 0; i < wwwe.length; i++) {
     out.writeUTF( wwwe[i] );
    }
    
  }

  public String toString(){ 
String  st = command+" "+name+" ";
for (int i = 0; i < wwwe.length; i++) {
  st += wwwe[i] + " ";
    }
return st;
}

}