/* Chat.java
 
 Copyright (C) 1998 Geometrek
 
 *  This file is part of DeepMatrix V1.
 *
 *  DeepMatrix V1 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix V1 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.chat;

import matrix.RoomControl;
import matrix.Message;
import matrix.deck.*;
import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;


/**
 *  chat only client for deepmatrix servers. can be used as applet or standalone program
 *
 * @version 1.0
 */
public class Chat extends Applet implements NetworkListener, UserInterfaceListener {
  // AWT stuff
  private Frontend gui;

  private String name, hostname = null, startRoom, openName = "default", openAvatar = "default", passWord = "default", sVendor, sOS1;
  private Backend network;
  private int port = 6666;
  private Vector ChatVec2 = new Vector(),ChatVec3 = new Vector(),ChatVec4 = new Vector();
  private boolean application = false, chatbool2 = true, bigchat = false, bRoom = false, bFirstRoom = true;
  private Cretan CRT;
  private Chatloader CL;
  private WindowListenerChat wl = null;
  private Heart hb = null;

/**
 * inits UI and network backend.
 */
  public void init() {
    sVendor =  System.getProperty("java.vendor").toLowerCase(); 
    sOS1 = System.getProperty("os.name").toLowerCase();
  if((sVendor.indexOf("netscape")==-1)&&(!sOS1.equals("mac"))){
wl = new WindowListenerChat(this);
 }
    hb = new Heart();
    CRT = new Cretan();
    CL = new Chatloader( this );
    String arg;

    try {
      network = new Backend( this );
    }
    catch(IOException e){
      System.err.println("PANIC : can't start Network Backend "+e);
    }

    if( application == false ){

    arg = getParameter("Port");
    if( arg != null )
      port = Integer.parseInt(arg);
    startRoom = getParameter("Room");
     arg = getParameter("Name");
     if(arg != null)
     openName = arg.replace(' ','_');
    arg = getParameter("OpenAvatar");
    if(arg != null)
    openAvatar = arg; 
    arg = getParameter("Passwd");
 if(arg != null)
 passWord = arg;
    arg = getParameter("Background");
    if( arg != null ){
      try{
        setBackground( new Color( Integer.valueOf( arg, 16 ).intValue()));
      }
      catch(NumberFormatException e){}
    }
    else setBackground( new Color( 192,192,192 ));

    arg = getParameter("Foreground");
    if( arg != null ){
      try{
        setForeground( new Color( Integer.valueOf( arg, 16 ).intValue()));
      }
      catch(NumberFormatException e){System.err.println("foregroundformat "+e);}
    }
    else setForeground( Color.black );
    }
    else {
      setBackground( new Color( 192,192,192 ));
      setForeground( Color.black );
    }

    setLayout( new GridLayout(1,1,0,0));
    if(openName.equals("default")&&openAvatar.equals("default")){
    gui = new Frontend( false, this, this);
    add( gui ); }
    else {
     gui = new Frontend( true, this, this);
    add( gui );
     gui.setUserName( openName );
     gui.setPassWord( passWord );
     }
    validate();
  }

  public void start() {
  getFocus();
  }

  public void stop(){
    network.disconnect( "false" );
    network.close();
  }

/**
 * callback for AWT
 */
  public void handleConnect( String loginName, String password, String avatarUrl ) throws InterruptedException{
  boolean bSocket = true;
  name = loginName;
   if( name.equals("") ){ gui.setStatus("Please enter a user name !");}
   else {
   if( application == false ){
          hostname = getCodeBase().getHost();
        }
        if( hostname.equals("")) hostname = "127.0.0.1";
        gui.setStatus("Trying to connect to "+hostname);
        try {
          network.connect(hostname, port, name, name, startRoom,"BOT" );
        }
        catch( IOException e){  bSocket = false;
          try {
						if( application == false && getParameter("HTTPTunnel") != null ){                
							URL servlet = new URL( getCodeBase(), getParameter("HTTPTunnel"));
							gui.setStatus("Trying to connect to Servlet at "+servlet.toExternalForm());
							network.connect(servlet.toExternalForm(), 80, name, name, startRoom, "BOT" );
						} else {
							throw new IOException("No fallback parameters defined !");
						}
					}
					catch(IOException f){
						gui.setStatus("Connecting failed : "+f);
						gui.showLoginView();
						return;              
				}
        }
        if(bFirstRoom==true){ CL.start(); bFirstRoom = false; }
        gui.showRunView();
        gui.display("DeepMatrix","connected to "+ hostname);
       if(bSocket==true){ hb = new Heart( this, 7000 ); }
      }
    }

  public void handleBeamto( String value, boolean objtf ){
  }

  public void handleDisconnect2()  {
  hb.stop();
  CL.stop();
  network.disconnect( "false" );
  network.close();
if(wl!=null){wl.removeWindowListener();}
  }

     public void handleIgnore( String target, boolean hidestate ){
  }

  public void handleUserView( String target, boolean objtf ){
  }

 public void handleObjRequest( String name, int state ){
 }

   public void handleRoomRequest( String target ){
   }



  public void handleRoomControl( int com, String name, String [] info  ){
 }


  public void handleNewRoom( String room, String url ){
  }

  public void handleMatrixTextMsgs( String [] mtm ){
  }

  public void setStartRoom( String rm ){
  }

  public void handleObjectRoutes( String target ){
  }

  public void handleAvImages( boolean tf, boolean tf2, int iIMG ){
  }

  public void handleDisconnect(){
    resetChat();
    hb.stop();
    network.disconnect( "false" );
    gui.display("DeepMatrix","disconnected from "+ hostname);
    gui.showLoginView();
    
 }

  public void handleViewpoint( String st ){
 }

   public void handleNavigation( int num ){
  }

  public void handleSpeed( float ft ){
   }

  public void handleLOGOUT(){
    hb.stop();
    gui.showLoginView();
    gui.setStatus("Press CONNECT to login !");
  }

  public void handleOBJADD( String name, String url ){
  }

  public void handleOBJDEL( String name ){
  }

   public void handleOBJIGN( String name, String tf ){
  }
  
  public void handleCTRLEV( String name, String [] lock ){
  }

  	 public void handleROOM_A( String name ){
		gui.display("DeepMatrix", "changed to room "+name );
	}

	public void handleROOM_B( String name, String url ){
		gui.display("DeepMatrix", "changed to room "+name );
	}

    public void handleNetFailure( String reason ){
 }

  public void handleMSG( String from, String line ){
  CL.pleaseHoldup();
    gui.display( from, line );
  }

  public void handleWHOIS( String[] users ){
    gui.setUsers( users );
  }

  public void handleOBJIS( String[] objs ){
  }

  public void handleWWW( Message msg ){
  }

   public void handleNEWRM( String new_room ){
  }
 
    public void handleADMIN( int arg ){
   }

  public void handleERROR( String from, String line ){
    gui.display("Error", from+" "+line);
  }

  public void handleGesture( int gest ){
  }

  public void handleGhost( boolean value ){
  }

  public void handleNavChange( String [] types ) {
  }

  public void handleSpeedChange( float ft ){
   }

  public Chat(){
  }

   public void setUpChat( String line, String to ){
   if( line.startsWith("/")){
         resetChat();
            try {
              network.switchRoom( line.substring(1), "C" );
            }
            catch(IOException e){ System.err.println("IOEx in action : "+e);}
          }
    else {
   if(bRoom==false){ CL.stopChat( true ); bRoom = true; }
    if(!line.equals("")){String Mfs [] = {line,to};
   synchronized(CRT) {
  if(CRT.getCretan()==true){
      ChatVec3.addElement( Mfs );
     CRT.setCretan(false);
     CRT.notify();
       }
     }
    }
   }
  }

  public void setUpAdmin( int icom, String line1, String line2 ){
  }

   public void handleLoadSample( String sBT, boolean bObjtf ){
  }

     public void handleObjectInfoRequest( String objName ){
  }
/**
 *  New 11-12-05 setDownChat method accomplishes two things:
 *  1. Puts the user's String chat from a Vector to the
 *  handleChat method.
 *  2. It analyzes the user's String and breaks up any string lengths over 150,
 *  for dispersal over 3 second intervals to make things easier on the server/network.
 * 
 */

       public void setDownChat() throws InterruptedException {
   synchronized(CRT) {
  if(ChatVec3.isEmpty()&&ChatVec2.isEmpty()){
      CRT.wait();
   }
  else {
     int z = 1;
    String [] Mfs7 = new String[2];
    if(!ChatVec3.isEmpty()){
    Mfs7 = (String [])ChatVec3.firstElement();
    int d = Mfs7[0].length();
   if(150<=d){ 
   bigchat = true;
   Vector stg = new Vector();
   int b = 0; 
  for( int a = 0; a<d; a++){
     if(a==0){ b +=1; String st1 = Mfs7[0].substring(0,150);
       stg.addElement(st1); 
     }  
   if(150<=a&&(a%150==0)){
   if( 150<=(d-a)){  
         b +=1; 
   String st2 = Mfs7[0].substring((150*(b-1)),150*b);
   stg.addElement(st2);
    }
   else { String st3 = Mfs7[0].substring(a,d);
   stg.addElement(st3);
        }
    }
    }
    int c = stg.size();
  String Mfs2 [] = new String[c];
   for( int a = 0; a<c; a++){
   Mfs2[a] = (String)stg.elementAt(a);
    }
    int f = -1;
 for( int a = 0; a<c; a++){
  f = Mfs2[a].indexOf(". ");
   if(-1==f)
     continue;
     if(0<a){
    Mfs2[a-1] = Mfs2[a-1]+ Mfs2[a].substring(0,f+1);
    Mfs2[a] = Mfs2[a].substring(f+1,Mfs2[a].length());
       } 
    }
  if(f==-1){  
 for( int a = 0; a<c; a++){
 int g = Mfs2[a].indexOf(" ");
   if(-1==g)
     continue;
     if(0<a){
      Mfs2[a-1] = Mfs2[a-1]+ Mfs2[a].substring(0,g+1);
      Mfs2[a] = Mfs2[a].substring(g+1,Mfs2[a].length());
        } 
      }
     }
  for( int a = 0; a<c; a++){ 
 String Mfs5 [] = new String[2];
   Mfs5[0] = Mfs2[a]; Mfs5[1] = Mfs7[1];
  ChatVec2.addElement(Mfs5);
  }  
   stg.removeAllElements();
}   
  else { if(-1<d){
 String Mfs3 [] = {Mfs7[0],Mfs7[1]};
  ChatVec2.addElement(Mfs3);
      } 
     }
   ChatVec3.removeElementAt(0);
   }
 if(!ChatVec2.isEmpty()){
 z = ChatVec2.size();
 String[] tt = (String[])ChatVec2.firstElement();
 handleChat( tt[0], tt[1] );
 ChatVec2.removeElementAt(0);
      }   
   CRT.setCretan(true);
  if(2<z){ CRT.wait(4000);}
if(z==2){ if(bigchat==false){ CRT.wait(500);} else { CRT.wait(4000);}}
if(z==1){ CRT.wait(); }
      }
    }
  }

  public void handleChat( String line, String to ){
	if(network.isConnected()){	 
	    try {
		network.sendChatMessage(to, line);
	    }
	    catch(IOException e){
		System.err.println("IOEx in handleChat : "+e);
	    }
   gui.display( name, line);
  }
 }

 public void resetChat() {
  synchronized(CRT) {
    ChatVec3.removeAllElements();
     ChatVec2.removeAllElements();
    bigchat = false; 
  CRT.setCretan(true);
  CRT.notify();
    }
   }

  public void holdChat() throws InterruptedException {
    synchronized(CRT) { 
     CRT.wait();
    }
   }

   public void sendHeartBeat() throws IOException {
  network.sendHeartBeat( "BT" );
  }

   public void getFocus(){
 if(sVendor.equals("sun")){
 this.requestFocus();
     }
   }

  public Chat( String host, int port ){
    this.port = port;
    this.hostname = host;
    application = true;

    ChatFrame window = new ChatFrame( this, "DeepMatrix Chat V1.0");
    window.add( this );
    init();
    window.pack();
    window.show();
  }

  public static void main( String[] args ){
    String arg, host = "127.0.0.1";
    int port = 6666,i = 0;

    while (i < args.length ) {
      if( !args[i].startsWith("-")) {
        System.err.println("Usage: Chat [-host ahost] [-port aport]");
        return;
      }
      arg = args[i++];

      // use this type of check for arguments that require arguments
      if (arg.equals("-host")) {
        if (i < args.length)
          host = args[i++];
        else
          System.err.println("-host requires a hostname");
      }
      else if( arg.equals("-port")) {
        if(i < args.length){
          try {
            port = Integer.parseInt( args[i++] );
          }
          catch(Exception e){
            System.err.println("-port requires numeric argument");
            port = 6666;
          }
        }
        else
          System.err.println("-port requires a portnumber");
      }
    }
    new Chat( host,port );
  }
}
