/*
  CtrlEvent.java

  Copyright (c) 2008 Russ Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.deck;

/**
 * An interface for a specialized shared event which can be controlled by one
 * user. Hopefully this will be expanded for more than one user at a time.
 * @version 1.0
 */

public interface CtrlEvent {
  
   /**
    * Sets the name of the user controlling lock from the network.
    * Also clears the lock from the network with an empty string.
    */
    public void handleLock( String [] lock );


	public String ctrlName();
   /**
    * Is used to clean up some classes (but not all) that implement this interface.
	* Some classes also use the RealTimeConsumer interface in which case the
    * delete method there is used for clean up.
    */
  

	public void ctrlDelete();

}
