/*
  SharedObject.java

  Copyright (C) 2000 Geometrek
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 

package matrix.deck;

/**
 * SharedObject returned after loading it via the Viewer. This is actually
 * not a sharedObject but just an interface to get and set names. Derived
 * objects are typically holder classes for nodes loaded via viewer.
 * The data contained usually depends on the renderer used.
 *
 * @version 1.0
 */
public interface SharedObject {
    public void delete();
   /**
    * sets the name of the SharedObject
    */
    public void setName( String name );

	public void setUrl( String url );
   /**
    * returns the name of the SharedObject
    */
    public String getUrl();
    public String getName();
}
