/*
  UserInterfaceListener.java

   Copyright (C) 1998 Geometrek and 2009 in part by Russ Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 



package matrix.deck;

import matrix.RoomControl;

/**
 * The UserInterfaceListener interface is implemented by classes interested in GUI messages.
 *
 * @see matrix.deck.UserInterface
 * @version 1.1
 */
public interface UserInterfaceListener {

  public void handleConnect( String loginName, String password, String avatarUrl ) throws InterruptedException;

 //  public void chatOnly( String line, String to );
 
  public void setUpChat( String line, String to );

 // public void setUpAdmin( String line );
  public void setUpAdmin( int icom, String line1, String line2 );

  public void handleObjectInfoRequest( String objName );

  public void handleViewpoint( String sDesc );

  public void handleLoadSample( String sBT, boolean bObjtf );

  public void handleChat( String line, String to );

  public void handleGesture( int gest );

  public void handleGhost( boolean value );

//New 4_05_04 Beam to method added
  public void handleBeamto( String value, boolean objtf );

  public void handleIgnore( String target, boolean hidestate );


  public void handleRoomRequest( String target );

  public void handleRoomControl( int com, String nm, String [] info );

  public void handleNewRoom( String room, String url );

  public void handleObjRequest( String target, int state );

  public void handleUserView( String target, boolean objtf );

  public void handleMatrixTextMsgs( String [] mtm );

  public void setStartRoom( String rm );

  public void handleObjectRoutes( String target );

  public void handleDisconnect() throws InterruptedException;

  public void handleNavigation( int num );

  public void handleSpeed( float ft );

  public void handleAvImages( boolean tf, boolean tf2, int iIMG );
}
