/**
  Route.java

  Copyright (C) 1998 Geometrek

  This source is distributed as semi-opensource software. Please see the
  LICENSE file with this distribution or contact Geometrek (www.geometrek.com)
  for details.
*/

package matrix.deck.eai;

import matrix.RealTimeMessage;
import matrix.vrml.*;
import matrix.vrml.eai.*;
import matrix.deck.RealTimeConsumer;
import matrix.deck.CtrlEvent;
import matrix.deck.ConsumerException;
import matrix.deck.Network;
import java.io.*;
import vrml.external.*;
import vrml.external.field.*;
import vrml.external.exception.*;

/**
 * Controls a single network state with a users name. Hence a specialized Route
 *
 * @version 1.1
 */
public class CtrlRoute implements CtrlEvent, RealTimeConsumer,  EventOutObserver, Runnable {
    private String name;
    private String username = "";
    private String sLock = "#open";
    private Node myNode;
    private boolean continous = false, valChanged = false, echo = false, dead = false, lock = false;
    private EventOut callingEvent;
    private EventIn fromnet;
    private Network postOffice;
	private long sleep = 400;
	private int stor = 25;
    private int iVn = 0;
    private Field val= null, lastVal = null;
    private int type;
	private EventInSFString setName = null;
    private EventInSFString setLock = null;
    private CtrlName ctrlname;
    private Thread runner = null;
    public boolean bAvatar = false;


	public class CtrlName implements EventOutObserver {
 private EventOutSFTime time_out = null;

    public CtrlName( EventOutSFTime time_changed ) throws Exception {
	 time_out = time_changed;
 time_out.advise(this, new Integer(3) );
     }

	   public void callback(EventOut value, double time, Object data) {
	try {
	    if( value == null ) {
		System.err.println("Got null value from ");
		return;
	    }
	    if(!(value instanceof EventOut)) {
		System.err.println("value of class "+value.getClass().getName() );
		return;
	    }
		if( value.getType()== FieldTypes.SFTIME ) {
     setName.setValue(username);
	  if(sLock.equals("#open")){
     System.out.println("CtrlTime sLock is open " );
     postOffice.sendControlEvent( name, new String [] { username, "#lock"} );
     }
     else 
	 if(sLock.equals(username)&&!username.equals("")){
	 System.out.println("CtrlTime sLock was controlled now opening " );
     postOffice.sendControlEvent( name, new String [] { username,"#open"} );
       }
      }
      else
    return;
     } 
	 catch(InterruptedException f){} 
     catch(IOException e){System.err.println("Inner class CtrlName of " + name + ": " +e ); }
	 catch(Exception g){System.err.println("Inner class CtrlName of " + name + ": " +g ); }
   }

public void delete(){                              
if(time_out!=null){ time_out.unadvise(this);	
 time_out = null;
    }
   }

}

    
    public CtrlRoute( Node netnode, Network office, int VN, long slp, String user ) throws RuntimeException {
	postOffice = office;
	myNode = netnode;
	iVn = VN;
    sleep = slp;
    username = user;
    try {
	name = ((EventOutSFString)myNode.getEventOut("tag")).getValue();
	if(name.endsWith("_P")){
	stor = RealTimeMessage.POP;
     }
    if(name.endsWith("_F")){
    stor = RealTimeMessage.FOR;
    }
    System.out.println("CtrlRoute name-tag: " + this.name );
	continous = ((EventOutSFBool)myNode.getEventOut("cont")).getValue();
	echo = ((EventOutSFBool)myNode.getEventOut("echo")).getValue();
    ctrlname = new CtrlName( ((EventOutSFTime)myNode.getEventOut("control_time"))   );
    callingEvent = myNode.getEventOut("value_tonet");  // GC workaround
    callingEvent.advise(this, new Integer(0) );
    setLock = ((EventInSFString)myNode.getEventIn("set_lock"));
	setName = ((EventInSFString)myNode.getEventIn("set_name"));
    setName.setValue( name );
	fromnet = myNode.getEventIn("value_fromnet");
	type = (callingEvent.getType());
     }
    catch(NullPointerException f){ System.out.println( "CtrlRoute error: " + f ); }
    catch(InvalidEventInException g){System.out.println( "CtrlRoute error: " + g );  }
    catch(InvalidEventOutException h){System.out.println( "CtrlRoute error: " + h ); } 
    catch(Exception k){System.out.println( "CtrlRoute error: " + k ); }
	try {
	    lastVal = EAITool.makeField( callingEvent );
	}
	catch(MatrixInvalidFieldException e){
	    System.err.println("Route "+name+" exeption in constructor "+e);
	}
	if( continous == true ){
	    runner = new Thread( this, name );
	    runner.start();
	}
    }
    
    public void setName( String newname ){
	System.out.println("CtrlRoute new name-tag: " + newname);
	this.name = name;
    }

    public String getName(){
	return name;
    }
    
     

    public void handleMessage( String tag, Field data ) throws ConsumerException {
	if(!tag.equals(name))
	    throw new ConsumerException(name+" matches not "+tag);
	try {
	    EAITool.setEventIn( fromnet, data );
	    lastVal = data;
	}
	catch(Exception e){
	    throw new ConsumerException(name+"\n\t"+e);
	}
    }

    public void handleLock( String [] lock ){
    if(lock[0]!=null){ sLock = lock[0];
    if(setLock!=null){ setLock.setValue( sLock ); }
     }
    }

	 public String ctrlName(){
    return name;
    }   

	public void ctrlDelete(){
     }

public void userView( String target ){
}

public void objectRoutes( String target ){
 }

  public boolean getbAvatar(){
  return bAvatar;
     }

  public void setUserPosition( float[] flt ){
  }

    public void checkPosition(  float[] fUP, boolean bUPs ){
   }



 public void beamto( String target ){
}

    public void update(){
    }

    public void run(){
	while( Thread.currentThread() == runner ) {
   if(!sLock.equals("")&&sLock.equals(username)) {
	    try{
		if( valChanged == true ){
		    postOffice.sendRealTime( stor, name, val, echo );
		    lastVal = val;
		    valChanged = false;
		}
		Thread.sleep(400);
	    }
	    catch(InterruptedException e){}
	    catch(IOException e){
		System.err.println("IOEx in route "+name+".run\n\t"+e);
	    }
      }
	}
    }


  public void callback(EventOut value, double time, Object data) {
  if(!sLock.equals("")&&sLock.equals(username)){
    if( dead == true ) return;
    try {
        if( value == null ) {
        System.err.println("Got null value from "+name);
        return;
        }
        if(!(value instanceof EventOut)) {
        System.err.println("value of class "+value.getClass().getName()+" from "+name);
        return;
        }
        if(value.getType()==type){
        val = EAITool.makeField( callingEvent );
        if( continous == false ){
        postOffice.sendRealTime( stor, name, val, echo );
        lastVal = val;
        valChanged = false;
        }
        else valChanged = true;
        }
    }
    catch(Exception e) {
        System.err.println("Error converting msg from "+data+":"+e); return;
      }
     }
    }

    public void delete() throws RuntimeException {
	runner = null; 
if(callingEvent!=null){ callingEvent.unadvise(this); }
if(ctrlname!=null){ ctrlname.delete(); }
 fromnet = null; 
 val = lastVal = null;
 myNode = null;
 callingEvent = null;
 dead = true;
    }
}
