/*
  Beta.java


 Copyright (C) 1998 Geometrek	and 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 


package matrix.deck.eai2;

import matrix.Connection;
import matrix.Message;
import matrix.RealTimeMessage;
import matrix.WhoWhatWhere;
import matrix.RoomControl;
import matrix.deck.*;
import java.lang.ArrayIndexOutOfBoundsException;
import java.awt.*;
import java.applet.*;
import java.io.*;
import java.net.*;
import java.util.*;
import vrml.eai.*;
import vrml.eai.field.*;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent; 


/**
 *  Applet Client for EAI browsers.Uses an EAIViewer to handle EAI handles UI issues
 * as well as program control. It observes the network backend used to control
 * the connection to the server and acts upon updates from the backend.
 *
 * @version 1.07
 */

public class Beta extends Applet implements NetworkListener, UserInterfaceListener, ViewerListener, WindowListener, Avatarcom {

    /**
    * Frontend controls users interfaces
    */
 
    private Frontend gui;

    /**
     * EAIViewer controls VRML browser and EAI stuff
     */

    public EAIViewer viewer;
   /**
    * beta_updateOk means the VRML plugin has the begin and end update methods used in a later version of EAI.
    */
    private boolean beta_updateOk = false;
   /**
    * New 11-12-05 useravdone marked false means that incoming avatar info is stored in the objects Vector until either the World or another avatar is finished.
    * In previous Deep Matrix versions avatars were loaded ad-hoc. Now they are loaded one at a time.
    */ 
    private boolean finished = false;

    private boolean useravdone = false; 
   
	private boolean  bBGChange = false;
    private String   sBackground = "";
    private String   sNewBackground = "";
    private String   sForeground = "";
    private String   sNewForeground = "";
    private boolean  bFGChange = false;
    private boolean  bNetFailure = false;
    private boolean  bDisconnect = false;
     /**
     *  New 11-12-05 bConnectState shows if connection 
     */
    public boolean bLogOut = false;
    private boolean bConnectState = false;
    /**
     *  New 11-12-05 truth determines whether an avatar's name has been found in Vector TestVec or not.
     */
    private boolean truth = false;
    
     /**
     *  New 11-12-05 bViewer determines whether to addViewerlistener and start EAIViewer thread. Only changed once in life of Applet.
     */
    private boolean bViewer = true;
    

    private boolean bChatEnd = false, bRoomEnd = false;
    /**
     *  New 11-12-05 bigchat used to determine if user's chat string is over 150 characters.
     */
    
    private boolean bigchat = false;
    /**
     *  New 11-12-05 bRoom determines whether room is being changed so chat is stopped from entering network.
     */
    private boolean bRoom = false; 
	 /**
     *  New 11-12-05 bGate another boolean indicating whether room is being changed so chat is stopped from entering network.
     */
    private boolean bLabelWarn = false;
    private String [] sLabelButton = null;
    private boolean bGate = false;
     /**
     *  New 11-12-05 bdoneGB determines whether the small frame applet for Internet Explorer has succeeded in getting the VRML browser.
     */
    private boolean bdoneGB = false;
    private boolean bLocal = false;
    private boolean bObjList = false;
    private boolean bChatter = false;
    private boolean bPW = false;
    private static boolean bMain = true;
    /**
    * WorldOject controls main VRML world. It is loaded first. The boolean finish is marked true when the VRML in the WorldObject is completely read.
    */
   private WorldObject world;
     /**
      * Original 1.2.1 keeps stores incoming avatars.
      */
    private Vector objects = new Vector();
    
    /** 
     * New 11-12-05 Vectors keep track of Avatar objects 
     * TestVec is to see if avatar already exists. RemVec is to see if avatar has been removed.
     */  
     private Vector TestVec = new Vector(), RemVec = new Vector(), SharedObjectVec = new Vector(), SharedObjectReq = new Vector(); 
     /** 
     * New 11-12-05 Vectors keep track of Avatar objects 
     * ChatVec2 is part of Chat thread. Internet Explorer needs the user's chat input as a Thread
     * It will lock up otherwise. 
     *
      * New 11-12-05 ChatVec3 is again part of the user's chat thread. Another optimization is that the users
      * chat is limited to a string of 150 characters per packet accross the network. 
      */
    private Vector ChatVec2, ChatVec3; 
    private Vector vFileRecord;
    private Hashtable GuiLabels = new Hashtable();
    private String sNetFailure = "";
      /**
       *  Keeps applet parameter of "Room"
       */
    private String startRoom;
     /**
      *  user's name
      */
    private String name;
      /**
       *  user's name with a "_" in front of it
       */
    private String sVersion = "DeepMatrixIP9 version 1.04";
    private String name2; 
	private String slocalHost_IP = "127.0.0.1";
      /**
       * hostname keeps Application parameter for the host's name for the socket.
       */
    private String hostname; 
    private String directPath;
    //private String sFile;
      /**
       * Absolute url of user's avatar.
       */
    private String avatarUrl;
	private static String sShutdown = "";
      /**
       * Absolute url of current world.
       */
    private String sPreviousWorld = null;
    private String sTarget;
    private String worldUrl;
    private String sVendor;
    private String sOS1;
    private String sOS2;
    private String sOS3;
	private String sPassWord;
    private int    iOS = 0;
      /** 
       * New 11-12-05 used in Cortona workaround.
       */ 
    private String loadname;
      /** 
       * New 11-12-05 used in Cortona workaround.
       */ 
    private String loadurl;  
      /** 
       * New 11-12-05 FRAME holds applet parameter Frame. Looks to see if applet is in seperate frame from VRML file
       */
    private String FRAME = "default";
    private String sHTTPTunnel = null;
    private String sMVLOpen;
    private String sMVLClose;
    private String sAbsolutePath;
    private String sDirectory;
    private String sFile;
      /**
       * Backend class does all the network stuff.
       */
    private Backend network;
      /**
       * port holds Applet parameter for the chosen socket port
       */
    private int port = 6666, vpIndex = -1, iObjct = 0;

     /**
     * New 11-12-05 iRoomLoad tracks the time for the RoomLoader RL to run finalization and garbage collection between room changes.
     */

     private int iRoomLoad = 0;

	 private int iXPos = 32;	//( 32, 514, 960, 150 );

	 private int iYPos = 514;	//(int x, int y, int width, int height) 

	 private int iXSize = 960;

	 private int iYSize = 150;

	 private int iViewerLoad = 0;
     /**
     * The local port for Java client <-> Instant Player communication.
     */
	 private int iPort = 4848;
     private int iSA = -1;
     /**
     * New 11-12-05 tracks the number of rooms for RoomLoader so it can send correct agruement to server.
     */

     private int iWorldCount = 0;


    /**
     * New 11-12-05 trcnt is counts to 30 for clearing memory every thirty seconds 
     */
   
    private int trcnt = 0;

     /**
     * New 11-12-05 cDLcount is to track the number of attempts Cortona makes to call url. Part of Cortona workaround. 
     */
   
    private int cDLcount = 0;
    /**
     * New 11-12-05 counter keeps track of the number of worlds loaded.
     */ 
    private int counter = 0;

	private int iPL = 1;

    private long lSleep = 400;
 
     /**
      * UserAvatar class controls the user's avatar
      */
    private UserAvatar avatar;
      /**
       * oobe is to see if user is in ghost mode or not
       */
    private boolean oobe = false;
       /**
       * New 11-12-05 Mfstg and Mfstg2 are arrays for chat to VRML strings.
       */
    private String Mfstg [] = new String[2];

    /**
     * New 11-12-05 VRML eventins for chat strings to avatar and world
     */ 
    private EventInMFString yak = null;
     /**
     * New 11-12-05 VRML eventins for chat strings to world
     */  
    private EventInMFString worldchat = null;

    /**
     * New 11-12-05 CRT is a class synchronized as part of new chat thread mechanism.
     */
    private Cretan CRT;
    /**
     * New 11-12-05 Chatloader is threaded class for user's chat input. See setUpChat and setDownChat methods below.
     */
    private Chatloader CL;
     /**
     * New 11-12-05 URLTimer is threaded class for loading Avatars with Contact,CosmoPlayer and WorldView
     */
    private URLTimer URLT;

	private CretanString CVL;

	private ViewerLoader VL;
    private String  sLoadHtmlUrl;
    private String sClasspath;
    private boolean bUAD = true;
    private boolean bLoadHtml = false;
    private boolean bWorldChat = false;
	private AppFrame window;
    private MainInterrupt MI;
    private SmallApplet avImageWindow;
	private MatrixVRMLLauncher MVL;

    //private UserTalk UT = null;

    /**     		
     * inits UI and network backend. reads applet parameters and sets everything accordingly.
     * also implements some workarounds to Netscape bugs
     */
  public Beta( String file, MainInterrupt mi ){
  MI = mi;
  init();
  loadInit( file );
  start();
 }
 public void init() {
 sOS1 = System.getProperty("os.name").toLowerCase();
 sOS2 = System.getProperty("os.arch").toLowerCase();
 sOS3 = System.getProperty("os.version").toLowerCase();
 sClasspath = System.getProperty("java.class.path");
 int foo = sClasspath.indexOf("DeepMatrixIP9client.jar");
 sClasspath = sClasspath.substring(0,foo);
 sMVLOpen = sClasspath;
 sMVLOpen = sMVLOpen.replace('/', (System.getProperty("file.separator").charAt(0)) ); 
 sMVLOpen = sMVLOpen  + "browser_scripts" +	System.getProperty("file.separator");
 if(sOS1.indexOf("windows")!=-1){
 sMVLOpen = sMVLOpen + "WinInstantPlayer.bat";
 sMVLClose = "cmd.exe /E:1900 /C Taskkill  /IM InstantPlayer.exe /f /t";
 sShutdown = sMVLClose;
 }
 if(sOS1.indexOf("linux")!=-1){
 iOS = 1;
 sMVLOpen = sMVLOpen + "LinuxInstantPlayer.sh";
 sMVLClose = "pkill InstantPlayer";
 sShutdown = sMVLClose;
 }
 if(sOS1.indexOf("mac")!=-1){
 iOS = 2;
// sMVLClose = sMVLOpen;
 sMVLOpen = sMVLOpen + "MacInstantPlayer.sh";
// sMVLClose = sMVLClose + "MacKillInstantPlayer.sh";
 sMVLClose = "killall InstantPlayer";
 sShutdown = "killall InstantPlayer";
 }
 System.out.println("sMVLOpen: " + sMVLOpen );
 System.out.println("sMVLClose: " + sMVLClose );
 MVL = new MatrixVRMLLauncher( sMVLOpen, sMVLClose );
	try {
	    network = new Backend( this );
	}
	catch(IOException e){
	    System.err.println("PANIC : can't start Network Backend "+e);
	}
 sVendor =  System.getProperty("java.vendor").toLowerCase(); 
 String local = System.getProperty("user.dir");
 System.out.println("User directory: " + local);
 sDirectory =  "file://" + sClasspath + "world/html/";
 System.out.println("Local html url: " + sDirectory);
 System.out.println("Vendor: " + sVendor);

 System.out.println("OS name: " + sOS1);
 System.out.println("OS arch: " + sOS2);
 System.out.println("OS version: " + sOS3 );
    }

  public void loadInit(String file) {
        sFile = file;
          char x = '_';
          char y = ' ';
		vFileRecord = new Vector();
        File foobar;
        BufferedReader fin = null;
        Vector names = new Vector(), urls = new Vector(), lines = new Vector();
        Vector butnames = new Vector(), buturls = new Vector(), butdescs = new Vector();
        Vector labelnames = new Vector(), labeldescs = new Vector();
		Vector vAI = new Vector();
        Vector vAI2 = new Vector();
        String line, lower = null, avImages = null, background, foreground, keyword, keyword2;
        String liness [] = null;
        boolean bAv = false;
        int index = 1, maxNumber, avCT = 1, urlCT = 1, lineCT = 1, butnamesCT = 1, buturlsCT = 1, butdescsCT = 1, labelnamesCT = 1, labeldescsCT = 1, avImgCt = 0; 
		iPL = 1;
        bPW = false;
        try {
            foobar = new File(file);
            sAbsolutePath = foobar.getAbsolutePath();
		    sAbsolutePath = sAbsolutePath.substring(0, sAbsolutePath.indexOf(sFile) );
            fin = new BufferedReader(new FileReader(file));
            line = fin.readLine();
            while(line != null ) {
                if( line.length() > 0 ) {
					String sRecord [] = new String [2];
                    StringTokenizer token = new StringTokenizer(line," ");
                    keyword = token.nextToken(); 
                    if(keyword.charAt(0) != '#') {    // No Comment !
					sRecord[0] = keyword; 
                    if(!sRecord[0].equals("avlist_end")){ sRecord[1] = token.nextToken(); }
                    else { sRecord[1] = "";}
					    lower = keyword.toLowerCase();
                        if(lower.equals("room") ) {  // loglevel
							startRoom = sRecord[1];
                            startRoom = startRoom.replace('_',' ');
                        }
                        else if(lower.equals("port")) {  // portnumber
                            port = Integer.parseInt( sRecord[1] );
                        }
						else if(lower.equals("xpos")) {  // X position number
                            iXPos = Integer.parseInt( sRecord[1] );
                        }
						else if(lower.equals("ypos")) {  // Y position number
                            iYPos = Integer.parseInt( sRecord[1] );
                        }
						else if(lower.equals("xsize")) {  // X size number
                            iXSize = Integer.parseInt( sRecord[1] );
                        }
							else if(lower.equals("ysize")) {  // Y size number
                            iYSize = Integer.parseInt( sRecord[1] );
							                       }
						else if(lower.equals("passlevel")) {  // Password status
                                 try {
							 Integer INT = new Integer( sRecord[1] );
						    iPL =  INT.intValue();
                                     }
    					catch(NumberFormatException e){ System.err.println("passlevel "+e);}
                        }
                        else if(lower.equals("sleep")) { 
                        lSleep = Long.parseLong( sRecord[1] );
                        }
                        else if(lower.equals("hostname")) {
                            hostname = sRecord[1];
                        }
                         else if(lower.equals("httptunnel")) {
                                sHTTPTunnel = sRecord[1];
                        }
                         else if(lower.equals("path")) {
                            directPath = sRecord[1];
                        }
						 else if(lower.equals("localbrowser")) {
                            slocalHost_IP = sRecord[1];
                        }  
						else if(lower.equals("localport")) {
                            iPort = Integer.parseInt( sRecord[1] );
                        }  
                          else if(lower.equals("local")) { 
                           String li = sRecord[1];
                            li = li.toLowerCase();
                            if(li.equals("true")){
                                bLocal = true;
                              }
                            }
                        else 
                          if(lower.equals( ("line"+lineCT) )) {  
                            String li = sRecord[1];
                            li = li.replace(x,y);
                            lines.addElement(li);
                            lineCT +=1;
                        }
                  
                        else if(lower.equals("background")){   
                            sBackground = sRecord[1];
							sNewBackground = sBackground;
                           try {
		                    setBackground( new Color( Integer.valueOf( sBackground, 16 ).intValue()));
	                            }
	                     catch(NumberFormatException e){ System.err.println("backgroundformat "+e);}
                        }
                           else if(lower.equals("foreground")){ 
                            sForeground = sRecord[1];
                            sNewForeground = sForeground;
                           try {
		                    setForeground( new Color( Integer.valueOf( sForeground, 16 ).intValue()));
	                            }
	                     catch(NumberFormatException e){ System.err.println("foregroundformat "+e);}
                        }
                        else 
                             if( lower.equals( "avimg_url" )){
						avImages = sRecord[1];
                        if(!sRecord[1].startsWith("http://")){
						 if(sOS1.indexOf("windows")!=-1){ 
avImages = sAbsolutePath + "world" + File.separatorChar + "Avatars" + File.separatorChar + avImages;
 }
 else {
avImages = sClasspath + "world/Avatars/" + avImages;
   }
 }
 bAv = true;
      }
                        else
                             if(lower.equals( ("avatar"+avCT) )) {
                               if(bAv){
                               String avline = sRecord[1];
                               avline = avline.replace(x,y);  
                               names.addElement(avline);
                                 avCT +=1;
                                  }
                                 } 
                        else  if(lower.equals( ("avatarurl"+urlCT) )) { 
                               if(bAv){ 
                               urls.addElement(sRecord[1]);
                                 urlCT +=1;
                                   }
                                  } 
                        else if(lower.equals("avlist_end")){
								if(bAv){ 
								String[] h1 = new String[names.size()];
	                            String[] h2 = new String[urls.size()];
	                           for( int i = 0; i < h1.length ; i++ ) {
	                            h1[i] = (String)names.elementAt(i);
	                            h2[i] = (String)urls.elementAt(i); 
                               }
						  Image avimg = null;
						  File iFile	= new File(avImages);
                          if(iFile.exists()){ 
                          URI uri = iFile.toURI();
                          try {
                          System.out.println( uri.toString() );
                          avimg = Toolkit.getDefaultToolkit().getImage( uri.toURL() );
                           }
                           catch(NullPointerException e){
						    System.out.println( "Problem with " + avimg + " url: " + e );
                            break;
                          }
                            catch(MalformedURLException mue ){
						  System.out.println( "Problem with " + avimg + " url: " + mue );
                            break;
                            }

						  AvImageLib ail = new AvImageLib( avImages, h1, h2  );
                          vAI2.add( avImgCt, avimg );
                          vAI.add( avImgCt, ail );
						  avImgCt += 1;
                          }
                          names.removeAllElements();
                          urls.removeAllElements();
                          bAv = false;
                            } 
                           }
						   else 
                             if(lower.equals( ("butnames"+butnamesCT) )) {
                               String lnkline = sRecord[1];
                               lnkline = lnkline.replace(x,y);  
                               butnames.addElement(lnkline);
                                 butnamesCT +=1;
                                 } 
    						else  if(lower.equals( ("buturls"+buturlsCT) )) {  
                               buturls.addElement(sRecord[1]);
                                 buturlsCT +=1;
                                  }
								else  if(lower.equals( ("butdescs"+butdescsCT) )) { 
                                String descline = sRecord[1];
                                descline = descline.replace(x,y); 
                               butdescs.addElement(descline);
                                 butdescsCT +=1;
                                  }
							  	else 
                             if(lower.equals( ("labelnames"+labelnamesCT) )) {
                               String lnkline = sRecord[1];
                               lnkline = lnkline.replace(x,y);  
                               labelnames.addElement(lnkline);
                                 labelnamesCT +=1;
                                 } 
								else  if(lower.equals( ("labeldescs"+labeldescsCT) )) { 
							     String descline = sRecord[1];
                                descline = descline.replace(x,y);
                               labeldescs.addElement(descline);
                                 labeldescsCT +=1;
                                  }
                    
                  }
                 else { sRecord[0] = line; sRecord[1] = ""; }
              //  System.out.println("sRecord length: " + sRecord.length );
				vFileRecord.addElement(sRecord);
                }
                line = fin.readLine();
                index++;
            }
        }
        catch(ArrayIndexOutOfBoundsException aioobe ){
        System.out.println("Error: ArrayIndexOutOfBoundsException thrown! " );
		System.out.println("Please check to make sure the 'AvatarUrl' keyword has the same suffix number at its corresponding 'Avatar' keyword above it! " );
		System.out.println("Correct example: Avatar12 then AvatarUrl12 " );
        System.out.println("Wrong example: Avatar12 then AvatarUrl11 will throw this error!");
        }
        catch(Exception e) { 
            fail(e,"Error reading "+file+" in line "+index); 
        }
        finally { 
            try{ 
                if(fin != null) 
                    fin.close(); 
            } 
            catch(Throwable e) {}
        } 
  window = new AppFrame(this, "Deep Matrix Client for Instant Player" );
  window.addWindowListener(this);
  window.add( this );
   if( lines.size() > 0 ){
	    liness = new String[lines.size()];
	    for( int i = 0; i < lines.size(); i++ ){
		liness[i] =(String)lines.elementAt( i );
	    }
	   }
	setLayout( new GridLayout(1,1,0,0));
	gui = new Frontend(this, liness, this, iPL, sAbsolutePath, sClasspath, iOS  );
	add( gui );
if( vAI2.size() > 0 ){
	    Image [] ims = new Image[vAI2.size()];
	    for( int i = 0; i < vAI2.size(); i++ ){
		ims[i] = (Image)vAI2.elementAt( i );
	    }
  avImageWindow = new SmallApplet( "Avatar Images", ims, 0, 0, 960, 518 );
	   }
  gui.setAvatarImages( vAI );
	for( int i = 0; i < butnames.size(); i++ ) {
	 String [] b2 = new String [2];	
	 String b1 = (String)butnames.elementAt(i);
	        b2[0] = (String)butdescs.elementAt(i);
		    b2[1] = (String)buturls.elementAt(i);
	   GuiLabels.put(b1,b2);
	}
		for( int i = 0; i < labelnames.size(); i++ ) {
	 String [] l2 = new String [2];	
	 String l1 = (String)labelnames.elementAt(i);
	        l2[0] = (String)labeldescs.elementAt(i);
		    l2[1] = null;
	   GuiLabels.put(l1,l2);
	}
  System.out.println(sAbsolutePath);
 validate();
 window.pack();
 if(1<iPL){
 iYPos = iYPos - 25;
 iYSize = iYSize + 25;
 }
 window.setBounds( iXPos, iYPos, iXSize, iYSize );
 gui.setSize( iXSize, iYSize );
 window.show();

}

/**
 * Gets a reference to the plugin. This should be done in start not in init !
 * New 11-12-05 Checks to see if html browser is InternetExplorer or Netscape
 * for using this Beta applet in a seperate frame from the VRML scene
 * If netscape the browser is gotten with standard EAI Browser.getBrowser(applet,frame,index)
 * call. Otherwise it calls GetBrowser applet in the VRML frame to pass the Browser object 
 */
  public void start(){
  counter = 0;
 URLT = new URLTimer();
 URLT.start();
 CVL = new CretanString();
 ChatVec2 = new Vector(); 
 ChatVec3 = new Vector();  
 CRT = new Cretan();
   VL = new ViewerLoader( this );
  VL.start();
 CL = new Chatloader( this );
  CL.start();
  viewer = new EAIViewer( sVendor, sOS1, sOS2, sOS3, sShutdown, slocalHost_IP, iPort );
  viewer.addViewerListener( this );
  network.setViewer( viewer );
  }
   
 public static void main(String[] args){
 (Thread.currentThread()).setName("DM_Main");
 String rcfile = null; 
 Runtime rt = Runtime.getRuntime();
    rt.addShutdownHook( 
	new Thread() {
      public void run() { 
        try {
 Runtime.getRuntime().exec( sShutdown );
   }
catch(IOException f){ }
  }
 }
);
 System.out.println( "Matrix client starting up ...");
 if( 2==args.length ){
  if( args[0].equals("-rcfile") ) {
  rcfile = args[1];	
   }
   else {  
     usage(); bMain = false;
          }
        }
 if( 2<args.length||1==args.length ){ usage();bMain = false; }
 if( 0==args.length ){ rcfile = "matrixclientrc"; bMain = false; }
 bMain = true; 
 Beta deck = new Beta( rcfile, new MainInterrupt( Thread.currentThread()   ) );  
    while(((Thread.currentThread()).getName()).equals("DM_Main")) {
   EAIViewer.setbSClose();  
   try{
  Thread.sleep(86400000);
     }
catch(InterruptedException ie ){
 System.out.println("calling EAIViewer.setbSClose by Main throwing: " + ie );
 EAIViewer.setbSClose();
    try{
  Thread.sleep(86400000);
    }
catch(InterruptedException ie2 ){}
   }
  }
 }
 
  public static void usage(){
        System.err.println("Usage : java matrix.server.MatrixD  [-rcfile name]");
        System.exit(1);
    }

 public static void fail( Throwable e,String msg ) {
        System.err.println("Matrix client application "+msg+":"+e);
        System.exit(1);
    }


  // Avatarcom interface

  public void handleDeselect( boolean tf ){
  }


    // UserInterfaceListener interface begin

    public void handleConnect( String loginName, String password, String avatarUrl ) throws InterruptedException {
	// initialization didn't work !!
	if( viewer == null )
	    return;
	// we keep them for later
	bDisconnect = false;
	bLogOut = false;
    sPassWord = password;
 SharedObjectReq.removeAllElements();
 SharedObjectVec.removeAllElements();
 objects.removeAllElements();
 TestVec.removeAllElements();
 RemVec.removeAllElements();
	name = loginName;
 name2 = "_"+name;
  viewer.setUserName( name2 );
	this.avatarUrl = avatarUrl;
	if( loginName.equals("") ){
	    gui.setStatus("Please enter a user name !");
	    return;
	}
  sTarget = startRoom;
 gui.setStatus("Trying to connect to "+hostname);
 String sCmd = "START";
 if(bNetFailure){ 
 sCmd = "RESTART";
 }
 synchronized(CVL){
 CVL.setString(sCmd);
 CVL.notify();
    }
   }



/**
 *  New 11-12-05  seUpChat method was implemented to turn the user's
 *  chat input String into the context of a Thread. A work-around
 *  for Internet Explorer to lockup when a user's chat enters the
 *  Frontend's display at the same time as chat Strings coming in
 *   from the Backend network
 * 
 */

       public void setUpChat( String line, String to ){
      if(line.startsWith("/admin")) {
	  try {
   network.askAdminControl( line.substring(1,5), line.substring(7)  );
     }
    catch( StringIndexOutOfBoundsException f ){ gui.display( "Matrix","Please include a password!");}
	catch( IOException e ){
    System.err.println("ControlMessage error asking AdminControl "+e);
	    }
      }
      else {
      if(line.equals("/stop heart")){ viewer.setbNet(false); System.out.println("stopping heart"); }
      if(line.equals("/start heart")){ viewer.setbNet(true); System.out.println("starting heart"); }
      if(line.equals("/version?")){ gui.display( "Matrix",sVersion); }
      else { 
   if(bRoom==false){ CL.stopChat( true ); bRoom = true; }
    if(!line.equals("")){String Mfs [] = {line,to};
   synchronized(CRT) {
  if(CRT.getCretan()==true){
      ChatVec3.addElement( Mfs );
     CRT.setCretan(false);
     CRT.notify();
       }
      }
     }
    }
   }
  }

   public void setUpAdmin( int icom, String line1, String line2 ){
    try {
   network.sendAdminControl( icom, line1, line2 );
     }
	catch( IOException e ){
                System.out.println("error sending AdminControl "+e);
	    }
  }

	 public void handleViewDescriptions( String [] sDescs ){
     gui.setViewDescriptions( sDescs );
     }

     public void handleViewpoint( String sDesc ){
     if(world!=null){
     world.setViewpoint( sDesc );
      }
     }

     public void handleLoadSample( String sBT, boolean bObjtf ){
      System.out.println("'Load-Sample' has not been implemented yet!");
	  gui.display("Matrix","'Load-Sample' has not been implemented yet!" );
  }

  public void handleObjectInfoRequest( String objName ){
  }
 

/**
 *  New 11-12-05 setDownChat method accomplishes two things:
 *  1. Puts the user's String chat from a Vector to the
 *  handleChat method.
 *  2. It analyzes the user's String and breaks up any string lengths over 150,
 *  for dispersal over 3 second intervals to make things easier on the server/network.
 * 
 */

       public void setDownChat() throws InterruptedException {
   synchronized(CRT) {
     int z = 1;
    String [] Mfs7 = new String[2];
    if(!ChatVec3.isEmpty()){
    Mfs7 = (String [])ChatVec3.firstElement();
    int d = Mfs7[0].length();
   if(150<=d){ 
   bigchat = true;
   Vector stg = new Vector();
   int b = 0; 
  for( int a = 0; a<d; a++){
     if(a==0){ b +=1; String st1 = Mfs7[0].substring(0,150);
       stg.addElement(st1); 
     }  
   if(150<=a&&(a%150==0)){
   if( 150<=(d-a)){  
         b +=1; 
   String st2 = Mfs7[0].substring((150*(b-1)),150*b);
   stg.addElement(st2);
    }
   else { String st3 = Mfs7[0].substring(a,d);
   stg.addElement(st3);
        }
    }
    }
    int c = stg.size();
  String Mfs2 [] = new String[c];
   for( int a = 0; a<c; a++){
   Mfs2[a] = (String)stg.elementAt(a);
    }
    int f = -1;
 for( int a = 0; a<c; a++){
  f = Mfs2[a].indexOf(". ");
   if(-1==f)
     continue;
     if(0<a){
    Mfs2[a-1] = Mfs2[a-1]+ Mfs2[a].substring(0,f+1);
    Mfs2[a] = Mfs2[a].substring(f+1,Mfs2[a].length());
       } 
    }
  if(f==-1){  
 for( int a = 0; a<c; a++){
 int g = Mfs2[a].indexOf(" ");
   if(-1==g)
     continue;
     if(0<a){
      Mfs2[a-1] = Mfs2[a-1]+ Mfs2[a].substring(0,g+1);
      Mfs2[a] = Mfs2[a].substring(g+1,Mfs2[a].length());
        } 
      }
     }
  for( int a = 0; a<c; a++){ 
 String Mfs5 [] = new String[2];
   Mfs5[0] = Mfs2[a]; Mfs5[1] = Mfs7[1];
  ChatVec2.addElement(Mfs5);
  }  
   stg.removeAllElements();
}   
  else { if(-1<d){
 String Mfs3 [] = {Mfs7[0],Mfs7[1]};
  ChatVec2.addElement(Mfs3);
      } 
     }
   ChatVec3.removeElementAt(0);
   }
 if(!ChatVec2.isEmpty()){
 z = ChatVec2.size();
 String[] tt = (String[])ChatVec2.firstElement();
 handleChat( tt[0], tt[1] );
 ChatVec2.removeElementAt(0);
      }   
   CRT.setCretan(true);
  if(2<z){ CRT.wait(4000);}
if(z==2){ if(bigchat==false){ CRT.wait(500);} else { CRT.wait(4000);}}
if(z==1){ CRT.wait(); }
    }
  }


    public void handleChat( String line, String to ){
	if(network.isConnected()){	 
	    try {
		network.sendChatMessage(to, line);
	    }
	    catch(IOException e){
		System.err.println("IOEx in handleChat : "+e);
	    }
   gui.display( name, line);
  	 Mfstg[0] = name;
    Mfstg[1] = line;
  //if(yak!=null&&to==null){ yak.setValue(Mfstg);}
  if(to==null&&world!=null) { world.setWorldMessage( line, name); } 
  if(bChatter==true&&to==null){ avatar.chatDisplay(Mfstg);}
       }
    }
 
   /**
 *    New 11-12-05 handleChat2 method delivers chat strings from the VRML World
 *    via WorldSendChat class, if it has "MatrixSendChat" Proto implemented.
 */
       public void handleChat2( String line, String to ){
	if(network.isConnected()){	 
	    try {
		network.sendChatMessage(to, line);
	    }
	    catch(IOException e){
		System.err.println("IOEx in handleChat : "+e);
	    }	
   gui.display( name, line);
   if(world!=null)world.setWorldMessage( line, name);
   // handleWorldChat( line, name);
          }
    }

    public void handleChat3( String line, String loc ){
     gui.display( loc, line);
   if(world!=null)world.setWorldMessage( line, loc );  
    }

  /**
 *    New 11-12-05 handleWorldChat method delivers chat strings to the World
 *    if it has "MatrixReceiveChat" Proto implemented.
 */

     public synchronized void handleWorldChat( String line, String from ){
    if(worldchat!=null) { 
    String Mfs [] = {from,line};
   worldchat.setValue(Mfs);
     }
  }



 /**
 *  New 11-12-05 resetChat method resets the user's chat thread when switching rooms
 *  and disconnecting.
 */

    public void resetChat() throws InterruptedException {
  synchronized(CRT) {
    ChatVec3.removeAllElements();
     ChatVec2.removeAllElements();
    bigchat = false; 
  CRT.setCretan(true);
  CRT.wait();
    }
   }

 /**
  *  New 11-12-05 holdChat method makes the thread of ChatLoader class
  *  wait at start up. 
  */

   public void holdChat() throws InterruptedException {
    synchronized(CRT) { 
     CRT.wait();
   }
   }


    public void holdVL() {
    synchronized(CVL) { 
     try {
      CVL.wait();
     }
   catch( InterruptedException e ){}
    }
   }


    public void handleGesture( int gest ){
	if( avatar != null ) {
	    avatar.gesture( gest );
	}
    }

      public void handleIgnore( String target, boolean hidestate  ){ 
     if(!hidestate){
	handleUserView( target, false );
    }
 }

    public void handleGhost( boolean value ){ 
	if( avatar != null ) {
	    if( value == false )
		avatar.hide();
	    else
		avatar.show();
	}
    }

     public void handleSpeed( float ft ){
    if( world!= null){
       world.setSpeed( ft );
      }
    }

   public void getFocus(){
 if(sVendor.equals("sun")){
 this.requestFocus();
     }
   }

   public void handleCTRLEV( String target, String [] lock ){
 if(world!=null){
  world.handleControlEvent( target, lock );
   }
  }

 
  /**
   *  New 11-12-05 Sends name of beamto target av to RealTimeHandler via Backend.
   */

 public void handleBeamto( String value, boolean objtf ){
if(value!=null&&name.indexOf(value)==-1){ 
  avatar.beamtostate = true;
if(!objtf){ network.beamtotarget( "_"+value );	}
else { network.beamtotarget( value );}
}
else {
gui.display("Matrix","Please select a user to beam to !" ); 
}}
 //throws InterruptedException  
   
public void handleDisconnect2()  {
  stop();
window.removeWindowListener(this);
System.exit(0);
  }
 
 public void handleRoomRequest( String target ){
   gateFired( target );
 }

 public void handleRoomControl( int com, String  nmpw, String [] info  ){
  try {
network.sendRoomControl( new RoomControl( com, nmpw, info ) );
  }
catch(IOException e){ System.err.println("Beta handleRoomControl: " + e); }
 }

 public void handleNewRoom( String name, String url ){
 try {
network.sendNewRoom( name, url );
  }
catch(IOException e){ System.err.println("Beta handleRoomRequest: " + e); }
 }

public void handleObjRequest( String target, int state ){
 if(0<state){
 SharedObjectReq.addElement(target);
 }
if(world!=null&&avatar!=null){
world.beamingObjectName( target, avatar.getUserPosition_Rotation(), state );
}

 // try {  
 //  network.sendObjectRequest( target, tf );
//		          } catch( IOException e ){
//                System.err.println("error handleObjRequest "+e);
//	    }
 //       	catch(InterruptedException f){
//	    System.err.println("error handleObjRequest "+f);
//	    } 

 }

  public void handleUserView( String value, boolean objtf ){
// System.out.println("Beta: hUV: " + value);
  if(value!=null&&name.indexOf(value)==-1){ 
 if(!objtf){  network.setUserView( "_"+ value );}
 else { network.setUserView( value ); }
  }
 else {
 gui.display("Matrix","Please select a user to hide or show!" ); 
 } 
 }

 public void handleMatrixTextMsgs( String [] mtm ){
   if(world!=null){ world.setMatrixTextMsgs( mtm );	}
 }

 public void setStartRoom( String rm ){
 startRoom = rm; 
 if(sTarget.equals(startRoom)){
    if(bBGChange){ 
    sBackground = sNewBackground;
    gui.handleBGColor2(); 
	bBGChange = false; 
    }
    if(bFGChange){ 
    sForeground = sNewForeground;
    gui.handleFGColor2();
	bFGChange = false;
    }
 }
 String sR3 = "";
 PrintWriter RCwriter = null;
 // System.out.println("setStartRoom1 : " + sAbsolutePath + sFile );
	File sNewrc = new File(sAbsolutePath + sFile);
	 try {
    FileOutputStream fos = new FileOutputStream( sNewrc );
    RCwriter  = new PrintWriter(fos);
     }
  catch( IOException e ){ }
 if(RCwriter!=null&&vFileRecord!=null&&!vFileRecord.isEmpty()){
        for( int iCt = 0; iCt<vFileRecord.size(); iCt += 1 ){
       String [] st = (String [])vFileRecord.elementAt( iCt );
	//   System.out.println("setStartRoom2 st length: " + st.length );
    //   System.out.println("setStartRoom3 : " + st[0] );
	   String sNL = "";
       if(!st[0].startsWith("#")){
       String kw = st[0].toLowerCase();
	   if(kw.equals("room") ) {	
       st[1] = startRoom; 
       st[1] = st[1].replace(' ','_');
          }
       if(kw.equals("background")&&!sBackground.equals("")){
       st[1] = sBackground;
          }
	   if(kw.equals("foreground")&&!sForeground.equals("")){
       st[1] = sForeground;
          }
         sNL = st[0] + " " + st[1];
       } 
       else { 
         sNL = st[0];
       }
			try {
		    RCwriter.write( sNL );
			RCwriter.println();	    
		    RCwriter.flush();	    
		}
		catch(Exception e) { 
           }
          }
      RCwriter.close();
        }
 gui.display("Matrix", startRoom + " has been recorded as your new start-up room!" ); 
      }

 public void handleObjectRoutes( String target ){
 if(target!=null){
  network.setObjectRoutes( target );
  world.objectRoutes( target );
   }
  else {
 gui.display("Matrix","Please select an Object to Move!" ); 
 } 
 }

   public void handleAvImages( boolean tf, boolean tf2, int iIMG ){
   if(avImageWindow!=null){
   if(!tf2){
   if(tf){
  avImageWindow.show(); 
   }
   else {
  avImageWindow.hide(); 
    }
   }
 else {	
   avImageWindow.handleNewImage( iIMG );
    }
   }
   }

    public synchronized void handleDisconnect() throws InterruptedException {
   gui.display("Matrix","3D window will close shortly to clear memory!");
   bDisconnect = true;
      if(world!=null){ 
 world.reset();
 }
   gui.setbRun( false );
   gui.resetGui();
   URLT.setTruth( false ); 
   viewer.setbNet(false);
   viewer.setSwitch( -1 );
	bRoom = useravdone = finished = bConnectState = bChatter = false;
  CL.stopChat( false );
 SharedObjectReq.removeAllElements();
 SharedObjectVec.removeAllElements();
 objects.removeAllElements();
 TestVec.removeAllElements();
 RemVec.removeAllElements();
	if( avatar != null ){
	    try {
		network.deleteSharedObject(avatar.getName());
        network.removeConsumer(avatar.getName());
        if(viewer!=null){ viewer.removeSharedObject(avatar.getName()); }
	    }
	    catch(IOException e) {
		System.err.println("IOEx deleting avatar "+e);
	    }
	}
 network.disconnect( new String( "true" ) );
  }
  
  public void handleNavigation( int num ){
if(world!=null){ world.setNavigation( num ); }
 }

    // UserInterfaceListener end

    // NetworkListener interface begin

    public void handleLOGOUT(){
  gui.display("Matrix", "Closing 3D window...clearing memory...");
  viewer.setbNet(false);
     if(!bDisconnect){
  viewer.setSwitch( -1 );
  gui.setbRun( false );
  gui.resetGui();
  bRoom = useravdone = finished = bConnectState = bChatter = false;
 // gui.setGhost( false );
  URLT.setTruth( false ); 
   CL.stopChat( false );
if( avatar != null ){
	    try {
		network.deleteSharedObject(avatar.getName());
        network.removeConsumer(avatar.getName());
        if(viewer!=null){ viewer.removeSharedObject(avatar.getName()); }
	    }
	    catch(IOException e) {
		System.err.println("IOEx deleting avatar "+e);
	    }
	}
 // gui.resetChat( false );
    if(world!=null){ 
 world.reset();
    }
   }
//	if(bConnectState){
    try{ 
	gui.setWWW( new RoomControl( RoomControl.SET, " ", new String [] {"logout"} ) );
    }
    catch(IOException e){}
//  }
   //gui.setNavigation( false );
   //gui.stopWWWBuffer();
 
  	
	 synchronized(CVL){
  iViewerLoad = -1;
    if(bGate==false){
   System.out.println( "handleLOGOUT bGate false" );
	bLogOut = true;
 	gui.display("Matrix","disconnected from "+ hostname);
	CVL.setString("DISCONNECT");
  }
 else {
  
  System.out.println( "handleLOGOUT bGate true" );
 CVL.setString("GATE");
  }
 CVL.notify();
   }
   bGate = false; 
 }
    


 /**
 *  New 11-12-05 This method of the NetworkListener interface has been drastically changed and represents
 *  the key differences between the old www.geometrek.com Deep Matrix applet and my later versions
 *  In the old version after the enviroment world was finished any incoming avatar url was immediately
 *  loaded into the  viewer.addSharedObject method
 *
 *       public void handleOBJADD( String name, String url ){
	* if( finished == true ){
	    viewer.addSharedObject( name, generateUrl( url ));
	* }
	*  else {
	*    String[] tt = { name, generateUrl( url ) };
	*    objects.addElement( tt );
	*  }
 *   }
 *
 * Now if the VRML browser is attempting to load a avatar/vrmlobject, any new incoming avatar/vrmlobject
 * is stored in the objects Vector until the previous avatar is completely finished and running.
 * In other words the rate of avatar loading has been slowed down a bit.
 *
 */

   public void handleOBJADD( String name, String url ){
 if(!TestVec.contains( name )){
  RemVec.removeElement( name );
	if( finished == true ){
 if( useravdone == true ){
  gui.display("Matrix","loading Shared Object....");
// System.out.println("handleOBJADD 1: " + name);
  cDLcount = 0;
  String st = generateUrl( url ); 
   URLT.setTruth( false );
   viewer.addUserAvatar( name, st ); 
      useravdone = false;
	}
	else {
// System.out.println("handleOBJADD finish true useravdone false: " + name);	   
   String[] tt = { name, generateUrl( url ) };
	    objects.addElement( tt );
	 }
 } 
	else {
//  System.out.println("handleOBJADD finish false useravdone false: " + name);
	    String[] tt = { name, generateUrl( url ) };
	    objects.addElement( tt );
	   }
  }
 }

   // viewer.checkTestName( name );

   /**
 *  New 11-12-05 handleOBJDEL method has been modified to empty and add to the Vectors used
 * keep track of user avatars.
 */

    public void handleOBJDEL( String name ){
  // System.out.println("Beta handleOBJDEL: " + name );
  if(SharedObjectVec.contains( name )){ 
 String foo = name.substring(1,name.length()-4);
  gui.resetObjectMove( name );
  gui.deleteObjName( name ); 
  SharedObjectVec.removeElement( name );
   }
	network.removeConsumer( name );
 if(viewer!=null){ viewer.removeSharedObject( name ); }
 TestVec.removeElement( name );
  RemVec.addElement(name);
 if(useravdone==true){  System.gc(); System.runFinalization();}
    }

  public void handleOBJIGN( String name, String tf ){
  }                                                                                                                                                                         

/**
 *  New 11-12-05 First stage of new room transition of RoomLoader
 *  Does cleanup and now starts the viewer thread on first load
 *  Checks to see if VRML browser is Cortona or else to load or start correct Avatar loading class aid
 */
    public void handleROOM_A( String roomnm ) throws InterruptedException {
  }


 /**
  * new 11-12-05 Last stage of transition between rooms
  * Starts the Chat loader and if Cortona plugin creates an instance of CortDroneLoader class
  */

   public void handleROOM_B( String name, String url ) throws InterruptedException {
 bUAD = true;
 bConnectState = true;
 cDLcount = 0;
 world = null;
 avatar = null;
 sTarget = name;
if(GuiLabels.containsKey(name)){
sLabelButton = new String [2];
sLabelButton = (String[])GuiLabels.get(name);
bLabelWarn = true;
 }
  viewer.setbNet(true);
// gui.resetChat( true );
 bRoom = false;
 worldUrl = generateUrl(url);
// System.out.println("Beta handleRoom_B worldUrl: " + worldUrl );
 gui.setbRun( true );
//if(0<counter){ gui.resetGui(); System.out.println( "Beta handleROOM_B counter is greater than 0: " + counter ); }
   gui.display("Matrix","loading room "+name+" ( "+url+" )");
 if(bObjList){ setObjList( false ); }
  viewer.loadWorld( "world", worldUrl ); 

  }

 public void handleNetFailure( String reason ){
 setbNetFailure( true ); sNetFailure = reason;
 }

 private synchronized void setbNetFailure( boolean bTf ){
 bNetFailure = bTf;
 }

 /**
  * handles messages from chat and delivers them to chat display.
  */
    public void handleMSG( String from, String line ){
   CL.pleaseHoldup();
	gui.networkChatInput( from, line );
    }

  /**
  * handles user's names
  */



    public void handleWHOIS( String[] users ){
	//gui.setUsers( users );
    }

   public void handleOBJIS( String[] objects ){
   //  gui.setObjNames( objects );
    }

   public void handleWWW( Message msg ){
     gui.setWWW( msg );
   } 

  public void handleNEWRM( String new_room ){
	gateFired( new_room );
  }

   public void handleADMIN( int arg ){
	  switch( arg ){
        case 1 :
        handleMSG( "Matrix", "Welcome Admin!" );
        break;
        case 2 :
		handleMSG( "Matrix", "Goodbye Admin!" );
        break;
        }
	   gui.setAdmin( arg );
   }

 
  public void handleObjNames( String obj, String url ){
 // System.out.println("handleObjNames1: " + obj);
 if(SharedObjectReq.contains(obj)){
// System.out.println("handleObjNames SharedObjectReq contains: " + obj);
   try {  
   network.addSharedObject( obj, url );
		          } catch( IOException e ){
                System.err.println("error adding shared object "+e);
	    }
    SharedObjectReq.removeElement( obj ); 
   }
    SharedObjectVec.addElement( obj );
  }

    public void handleERROR( String from, String line ){
	gui.display("Error",from+" "+line);
if(line.equals("Still connected!")){ 
  gui.setStatus( name + " is still connected!");
   }
    }

   public void handleInitGuiNavigation( String [] type ){
  // System.out.println("Beta handleIGN");
   //gui.setInitGuiNavigation( type );
   }

   public void handleNavChange( String [] types ){
   gui.setNavChange( types ); 
   }

   public void handleSpeedChange( float ft ){
	gui.setSpeedChange( ft ); 
   }

    // NetworkListener interface end

   public void setObjList( boolean tf ){
  bObjList = tf;
  gui.setObjList( tf );
  }

  public Node getPrimeMover(){
  Node pm = world.getPrimeMover();
  return pm;
  }

    // ViewerListener interface start

  public void resetSystem(){
  gateFired( sTarget );
  }



 public void networkConsumers( boolean tf ){
if(tf){ 
   network.clearConsumers();
    yak = worldchat = null;
  }
  else {
	gui.showLoginView();
	gui.setStatus("Press CONNECT to login !");
   }
 }

   public void shutDownJava(){
    }

   public void onReset(){
   }
 
   public void openBrowser(){
   MVL.setOpen();
   }

   public void destroyProcess(){
   System.out.println("Beta destroyProcess");
   MVL.stop();
   }

    /**
     * new 11-12-05 onHeartBeat polls server every seven seconds with a new ContolMessage HRTBT
     * Called from EAIViewer run
     */

       public void onHeartBeat(){
      try {
   network.sendHeartBeat( "name" );	
      }
    catch(IOException e){  System.err.println("Beta hB1 IOExeption "+e); 
      }
    catch(NullPointerException f){
    network.clearConsumers();
    yak = worldchat = null;
	gui.showLoginView();
	gui.setStatus("Press CONNECT to login !");
    System.out.println("Beat onHeartBeat NPE: " + f);
    viewer.setbNet(false); return;
    }
     }

   /**
     * new 11-12-05 onWorldLoaded differs considerably from original Geometrek Deep Matrix applet
     * First it sees if the world has been removed by (RemVec Vector) by the handleOBJDEL method 
     * or if it already exists (TestVec Vector) If neither Vector contain the name, then the boolean
     * "truth" is made true and the object proceeds to load as a World class 
     * Otherwise a Deadend Class is called and the VRML is removed from the scene. The Deadend class
     * is only really necessary for Cortona and its lackadaisal Browser.createVRMLfromURL bug
     * With the work around I wrote by simply recalling the missing url the problem is this: Did
     * Cortona REALLY screw up and ignore the call OR is the network simply slow on delivering the goods?
     * If the latter is true, then object will show up twice. Deadend class will eliminate the successfull
     * second call
     * "Viewer.putSO" is a call back to the EAIViewer class to put the vrml object
     * in its objects hashtable IF there is no duplicate. Originally it went directly 
     * the objects hashtable before the Beta onObjectLoaded method was called
    */

     public void onWorldLoaded( String name, SharedObject object ){
     counter += 1; 
  if(!TestVec.contains(name)){ truth = true; TestVec.addElement(name);}
	// if nothing was loaded
 if(truth==true){
	if( object == null ){
	    System.out.println("Error loading world !");
	    gui.display("Matrix","could not load the world - disconnecting");
	    network.disconnect( "false" );
	    return;
	}

	// do the world parsing thing !!

 //viewer.putSO( (SO2)object );
	avatar = null;
    System.out.println("Beta onWorldLoaded1");
	try{
	    world = new WorldObject( (SO2)object, viewer.getBrowser(), network, this, vpIndex, viewer.getViewernum(), lSleep, sDirectory, worldUrl );
	}
	catch(ConsumerException e){
	    gui.display("Matrix",e.toString());
	    network.disconnect("false");
	    return;
	}
       	
}
else { 
 Deadend dead = new Deadend( (SO2)object );
  if(useravdone==true){  
 System.gc();
 System.runFinalization();
     } 
   }
    }

    /**
     * new 11-12-05 onObjectLoaded differs considerably from original Geometrek Deep Matrix applet.
     * First it sees if the object has been removed by (RemVec Vector) by the handleOBJDEL method. 
     * or if it already exists (TestVec Vector) If neither Vector contain the name, then the boolean
     * "truth" is made true and the object proceeds to load as either a UserAvatar or Avatar class. 
     * Otherwise a Deadend Class is called and the VRML is removed from the scene. The Deadend class
     * is only really necessary for Cortona and its lackadaisacal Browser.createVRMLfromURL bug.
     * With the work around I wrote by simply recalling the missing url the problem is this: Did
     * Cortona REALLY screw up and ignore the call OR is the network simply slow on delivering the goods?
     * If the latter is true, then object will show up twice. Deadend class will eliminate the successfull
     * second call.
    */

    public void onObjectLoaded( String name, SharedObject object ){
 if(RemVec.contains(name)) { truth = false; }
 else {
 if(!TestVec.contains(name)){ truth = true; TestVec.addElement(name);}
 else { truth = false; }
  }
 if(truth==true){
 if( object != null ){ 
// if(world!=null){ world.addSharedObject1( name, (SO2)object ); }
   // new 11-12-05 putSO is a call back to the EAIViewer class to put the vrml object
   // in its objects hashtable IF there is no duplicate. Originally it went directly 
   // the objects hashtable before the Beta onObjectLoaded method was called. 
	    // check for users avatar
	    if( name.equals( name2 )){
      // System.out.println("Beta onObjectLoaded UA");  world.getRoPo(),
		avatar = new UserAvatar( (SO2)object,  network, viewer.getBrowser(), world.getRoPo(),  world.getProxy(), this, viewer.getViewernum(), world.getOffset(), lSleep );
		network.addConsumer( avatar );
	    } else {
		Avatar av = new Avatar( (SO2)object, viewer.getBrowser(), network, this, viewer.getViewernum(), lSleep );
		//viewer.resetLoaded( (SO2)object );
		network.addConsumer( av );
		// get some updates for this object
        gui.confirmObjLoad( av.getName() );
if(bConnectState){
       // System.out.println("Beta oOL update: " + av.getName() );
		try {
		    network.update(av.getName(), av.getbObject() );
		}
		catch( IOException e ){
		    System.err.println("Error updating "+av.getName()+" "+e);
		}
 }
	    }
    //viewer.putSO( (SO2)object );
 } else {
	    System.out.println("Error loading object "+name+" !");
	  } 
  }
else { 
 viewer.resetLoaded();
 // System.out.println("Beta onObjectLoaded Deadend");
  Deadend dead = new Deadend( (SO2)object );
 // if(useravdone==true){ 
 //   System.gc();
 //  System.runFinalization();}
 System.out.println(name +" again deleted"); 
  }   
}

/**
 * New 11-12-05 world_loaded method is called when the VRML world is initialized.
 * It then calls the user's personal avatar. In previous versions of the applet the
 * the objects Vector was unloaded in the "onWorldLoaded" method above: 
 *
 * 
 *
 * In my opinion this was expecting too much out of the VRML plugin to work
 * well. The EAI had a tendency to get a head of itself and would try to do too much 
 * at one time and head for lock up. My system slows things down quite a bit. A new
 * VRML file is not loaded UNTIL the previous one is fully initialized!
 */
 

  public void world_loaded(){
 System.gc();
 System.runFinalization();
 // gui.setNavigation( true ); 
if(bConnectState){ 
 	gui.display("Matrix","world loaded !");
 network.addConsumer( world );
	// lets get some updates for the worlds states
	try {
	    network.update( "world", false );
	}
	catch( IOException e ){
	    System.err.println("Error updating world "+e);
	}
 finished = true;
 if(bLabelWarn){
 boolean bLB = true;
 if(sLabelButton[1]==null){
 bLB = false; 
 }
   handleGUIColors( "default", "default"); 
  handleLableAnchorInfo( bLB, sLabelButton );
 }
	if( avatarUrl != null ){
 //  System.out.println("Beta world_loaded avatarUrl not null");
 gui.display("Matrix","loading User's Avatar....");
   String st = generateUrl(avatarUrl);
   cDLcount = 0;
 URLT.setTruth(true); 
viewer.resetLoaded();
viewer.addUserAvatar( name2, st );
    }
   }
  } 

 /**
 * New 11-12-05 urlTimerLoad method called by URLTimer class. Contact, Cosmoplayer, WorldView only.
 */

   public void urlTimerLoad(){
 cDLcount +=1;
 URLT.sleepyTime();
   if(1<cDLcount&&cDLcount<4){ gui.display("Matrix","waiting...."); }
 if(4==cDLcount){
    if(!objects.isEmpty()){
    gui.display("Matrix","Failure to get url!"); 
    gui.display("Matrix","Loading next Shared Object!");
    userAvDone();
    } 
    else {  gui.display("Matrix","Failure to get url!"); 
           }
   }   }
 


/**
 * New 11-12-05 
 * user_av_finished is called to show user's personal av is done
 * UserAvatar must load between the World and drone Avatars.
 */

 public void user_av_finished(){
 // System.out.println("Beta user_av_finished");
	URLT.setTruth( false );
	viewer.resetLoaded();
   if(bConnectState){
  viewer.setHeartBeatCount(); 
   try {  
   network.addSharedObject( name2, avatarUrl );
		          } catch( IOException e ){
                System.err.println("error adding user avatar "+e);
	    } 
 // gui.setGhost( true ); 
  gui.display("Matrix","loaded User's Avatar!");
  userAvDone();
 if(world!=null){
  world.startInlineSearch();
        }
	   }
 	  } 

  public boolean checkIgnored( String nm ){
  boolean tf = gui.checkIgnored(nm);
   return tf;
   }

  public void removeSharedObject( SO object ){
   viewer.removeSharedObject2( object );
  }
 
 /**
 * New 11-12-05 drone_av_finished is called either when another users avatar
 * is finished and fully running OR if EITHER it or the user's avatar have
 * failed to load.
 * 
 */
     public void drone_av_finished( String nm, boolean tf ){
	   URLT.setTruth( false );
	viewer.resetLoaded();
   if(bConnectState){
  viewer.setHeartBeatCount(); 
 if(tf==true){ gui.display("Matrix","loaded Shared Object!"); }
 else { 
  viewer.removeSharedObject( nm );
  gui.display("Matrix","failed to load Shared Object!"); }
   userAvDone();
	}
  }

/**
 * New 11-12-05 userAvDone method is called by a finished World or avatar to see if there
 * are any waiting av urls in the objects Vector and attempts to have them called.
 */

  public void userAvDone(){ 
  int b = (objects.size()-1);
  if(-1<b){useravdone = false; 
	    String[] tt = (String[])objects.elementAt(b);
     objects.removeElementAt(b);
     cDLcount = 0;
   gui.display("Matrix","loading Shared Object....");
  URLT.setTruth( true );	
  viewer.addUserAvatar( tt[0], tt[1] );
	  }
else { useravdone = true; }
if(bUAD&&avatar!=null){ 
 gui.setGhostNav(); 
 bUAD = false; }
 }


    // ViewerListener interface end
   
  void gateFired( String target ){
    sPreviousWorld = sTarget;
	iViewerLoad = -1;
    bGate = true;
    sTarget = target;
     try{
	handleDisconnect();
     }
    catch(InterruptedException e){ System.out.println("Gate mis-fired: " + e ); }
    }

     public void browserControl( int iCtrl ){
// System.out.println( "browserControl first: " + iCtrl );
if(iCtrl==1){ gui.display("Matrix","Counting..1"); }
else
if(iCtrl==2){ gui.display("Matrix","..2"); }
else
if(iCtrl==3){ gui.display("Matrix","..3"); }
else
if(iCtrl==4||iCtrl==5){ 
if(iCtrl==4){  gui.display("Matrix","4! 3D Window re-opening!"); }
// System.out.println( "browserControl: " + iCtrl + " a");
MVL.setOpen(); 
viewer.setiStart( 1 );
// System.out.println( "browserControl: " + iCtrl + " b");
}
else
if(iCtrl==12){
MI.setInterrupt();
viewer.setiStart( 2 );
}
else
if(iCtrl==6||iCtrl==7){ 
String sGui = "";
if(iCtrl==6){ sGui = "3D window now closing....reloading in approx 4 seconds!"; }
else { sGui = "3D window now closing!"; }
gui.display("Matrix",sGui);
MI.setInterrupt();
viewer.setiStart( 1 );
}
else
if(iCtrl==13){
MVL.setClose();
viewer.setiStart( 2 ); 
}
else
if(iCtrl==8){
if(!bNetFailure){ gui.display("Matrix","Java EAI browser achieved!"); }
 reConnect(); 
 }
else
if(iCtrl==9){ gui.showLoginView();MVL.stop(); gui.setStatus("Error making connection to VRML !");}
else
if(iCtrl==10){ gui.display("Matrix","Now trying to getJava EAI browser!");}
else
if(iCtrl==11){ 
  MVL.stopEP(); 
    }
  }

    public void browserAchieved( boolean tf ){
if(tf){ reConnect(); }
else { 	gui.setStatus("Error making connection to VRML !");
}
  }


  private void reConnect(){
 if(counter==0){ 
 gui.setStatus("Connecting to "+hostname);
  }
 else {
 gui.setStatus("Reconnecting to "+hostname); 
  }
  gui.startWWWBuffer();
 String st;
 if(1<iPL){
  st = sPassWord;
  }
 else {
  st = name;
  }
	 	try {
	    network.connect(hostname, port, name, st, sTarget, "BOT" );
	}
	catch( IOException e){
   System.out.println("reConnect error: " + e );
            try {
			  if(!bNetFailure){
                if( sHTTPTunnel != null ){                
                    gui.setStatus("Trying to connect to Servlet at "+("http://" + hostname + "/" + sHTTPTunnel ));
                    network.connect(("http://" + hostname + "/" + sHTTPTunnel), port, name, name, sTarget, "BOT" );
                } else {
                    throw new IOException("No fallback parameters defined !");
                }
                }
              else {
    			   throw new IOException(sNetFailure);
               }
            }
            catch(IOException e2){
                gui.setStatus("Connecting failed : "+e2);
                gui.showLoginView();
                return;
            } 
	}
	gui.showRunView();
   if(bBGChange){
   try {
    gui.handleBGColor( new Color( Integer.valueOf( sBackground, 16 ).intValue()) );
	   }
   catch(NumberFormatException e){ System.err.println("reConnect backgroundformat "+e);}
     bBGChange = false;
          }
      if(bFGChange){
    try {
	gui.handleFGColor( new Color( Integer.valueOf( sForeground, 16 ).intValue()) );
	      }
	catch(NumberFormatException e){ System.err.println("reConnect foregroundformat "+e);}
	bFGChange = false;
          }
	repaint();
	validate();
 // passing browser name to RealTimeHandler via Backend so Cosmo and I.E. combo will work.

 beta_updateOk =  viewer.updateOk;
 network.BackendupdateOk(viewer.updateOk);
  gui.display("Matrix","connected to "+ hostname);
 setbNetFailure( false );
}




   public void reloadRoot(){
    synchronized(CVL){
String st = CVL.getString();
 if(st.equals("DISCONNECT")){
   viewer.viewerDisconnect( 0 );
  }
 else 
 if(st.equals("GATE")){
     viewer.viewerDisconnect( 1 );
   }
 else 
 if(st.equals("START")){
  System.out.println("reloadRoot START");
    viewer.viewerDisconnect( 2 );
   }
 else
 if(st.equals("RESTART")){
 System.out.println("reloadRoot RESTART");
    viewer.viewerDisconnect( 3 );
   }
  try {
  CVL.wait();
  }
  catch(InterruptedException f){ System.err.println("Ex in reloadRoot wait "+f);
     }
  }
} 
    /**
     * adds behaviours the behaviours of the used Avatar to the GUI
     */
    public void addBehavs( String[] behavs ){
	gui.setGestures( behavs );
    }

   /**
    * helper functions, accessible by everyone
    * should maybe be static but depend on getDocumentBase
    * exchange table for Blaxxun Url character problems,
    * the other browser work with the % version as
    * well as with the substitution, so no special cases for them :-)
    */

    private static String substitution[][] = {{"%7C","|"},{"%20"," "}};

    /**
     * little helper to construct URLs from DocumentBase.
     * usually used for URLs send to Cosmoplayer. Cosmoplayer 2.0 is inconsistend with
     * the base of relative URLs, so we avoid that by using only absolute ones.
     */
    String generateUrl( String url ){
String hs;
if(url.indexOf("http")==-1){
if(bLocal==false){
hs = ("http://" + hostname + directPath + url );
 }
 else {
 hs = url;
  }
 }
 else {
 hs = url;
 }
	return hs;
    }

/**
  *  New 11-12-05 trying to improve window closings in Netscape
  *  Notifying the synchronized classes of threads tends to cause crashes
  *  with Cosmoplayer so those calls have been removed. 
  *  See RealTimeHandler close method.
  *  Calling delete method of viewer has been commented out as well.
  *  Still some question about "what" to correctly stop.
 */
      public void stop(){ 
 useravdone = finished = false;
//if(viewer!=null){ viewer.delete();}
 network.disconnect("false");
 //network.close();
  VL.stop();
  CL.stop();  
 if(URLT!=null){  URLT.stop(); }
  yak = worldchat = null;
  System.runFinalization();
  System.gc();
  }


 /** 
  * New 11-12-05 Sets up Beta to deliver chat to UserAvatar class
  */

   public void set_yakker( EventInMFString talk_talk ){
  yak = talk_talk;       
  }

 /**
  *  New 11-12-05 Sets up Beta to deliver chat to World class
  */ 

   public void set_worldchat( EventInMFString talk_talk  ){
  worldchat = talk_talk;
  }

  /**
  *  New 11-12-05 Warns when loading WorldObject has a lot of Matrix Protos.
  */

  public void worldLoadWarning( String warning ){
  gui.display("Matrix", warning );
  }

  public void addCtrlEvent( CtrlEvent ce ){
  if(world!=null){
  world.addCtrlEvent( ce );
  }
  }

  public void removeCtrlEvent( String sCe ){
    if(world!=null){
  world.removeCtrlEvent( sCe );
  }
  }

 /**
 * New 11-12-05 Call back to world to reset viewpoint during UserAvatar construction.
 */

 public void setViewpoint(){
  world.setBinder();
}

 public float [] getWorldViewpointPos_Rot(){
 float [] fInfo = null;
if(world!=null){
 fInfo = world.getViewpointPos_Rot(); 
  }
return fInfo;
 }

    public Browser getBrowser(){
Browser br = viewer.getBrowser();
	return br;
    }

  public void chatDisplay ( boolean tf ){
   bChatter = tf;
    }

   public void handleMatrixText(){
   gui.setMatrixText();
   }


   public void handleCollide_Headlight( boolean bHL, boolean bMCOL, boolean bCOL ){
   gui.setCollide_Headlight( bHL, bMCOL, bCOL );
   }

  public void handleGUIColors( String BG, String FG ){
  if(!sTarget.equals(startRoom)){
	 if(!BG.equals("default")){
    sNewBackground = BG; 
	try {
   gui.handleBGColor( new Color( Integer.valueOf( BG, 16 ).intValue()));  
       }
	catch(NumberFormatException e){ System.err.println("handleBGColor backgroundformat "+e);}
    bBGChange = true;
     }
     if(!FG.equals("default")){
     sNewForeground = FG;
	 try {
    gui.handleFGColor( new Color( Integer.valueOf( FG, 16 ).intValue()));
	     }
	 catch(NumberFormatException e){ System.err.println("handleFGColor foregroundformat "+e);}
    bFGChange = true;
     }
    }
   }

  
 public void handleLableAnchorInfo(  boolean BC, String mst [] ){
    gui.setLableAnchorInfo( BC, mst );
    bLabelWarn = false;
  }

    public void sharedObjectName( String target, int state ){
  if(world!=null)
   world.sharedObjectName( target, state );
 }

  /**
 * New 11-12-05 set_AvatarName and set_AvatarUrl are called by World class if MatrixAvatar_Name_Url Proto has been implemented.
 */

 public String set_AvatarName (){
 return(name);
 }

     public String set_AvatarUrl (){
 return(avatarUrl);
 }

/**
* New 11-12-05 Gives UserAvatar target drone Avatar coordinates for beam to.
*/

  public void beamtocoord ( float[] beaminfo ){
   avatar.beamover(beaminfo);}
 /**
 * New 11-12-05 Feedback to Frontend that beamto is finished so select can be reset.
 */

  public void beamtoFinished (){
 gui.resetSelect(); 
 }

    /**
     * reads a file referenced by an URL. mostly used for reading wrl files, to work around
     * the insecure createVrmlFromURL call.
     * not really used in this version.
     */
    String readUrl( String url ) throws Exception {
	StringBuffer content = new StringBuffer();
	url = generateUrl( url );
	URL contentUrl = new URL( url );
	DataInputStream s = new DataInputStream( contentUrl.openStream());
	String line = s.readLine();
	while( line != null ){
	    content.append( line + "\n");
	    line = s.readLine();
	}
	s.close();
	return content.toString();
    }

    /**
     * WindowListener Interface begins
     */

public  void windowDeactivated( WindowEvent e ) {
 }
public  void windowActivated( WindowEvent e ) {
        getFocus();
 }
public  void windowDeiconified( WindowEvent e ) {
        getFocus();
 }
public  void windowIconified( WindowEvent e ) {
 }
public  void windowOpened( WindowEvent e ) {
  }
public  void windowClosed( WindowEvent e ) {
 }
public  void windowClosing( WindowEvent e ) {
     avImageWindow.goodbye(); 
	 gui.closeChatLogger();
	System.exit(0);
}

 }
