/*
  EAIViewer.java

Copyright (C) 1998 Geometrek	and 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */ 

package matrix.deck.eai2;

import java.io.IOException;
import matrix.deck.*;
import java.applet.*;
import java.util.*;
import java.net.UnknownHostException;
import java.net.InetAddress;
import vrml.eai.*;
import vrml.eai.field.*;
import vrml.eai.event.*;

/**
 * Viewer for EAI VRML browser connection. Does the basic EAI stuff such as
 * loading and removing of objects and worlds.
 *
 * @version 1.0
 */
public class EAIViewer implements Viewer, Runnable {

    private boolean bWorld = false;
   /**
    * New 11-12-05 viewernum is for which VRML plugin is being used.
    */
    private int viewernum = 0;
	private String slocalHost_IP = "127.0.0.1";
    private int iPort = 4848;
    private int iNodeCt = 0;
    private long lSleep = 1000;
    private byte [] bylocalHost_IP = new byte[4];
    /**
    * New 11-12-05 counter for heart beat every seven seconds.
    */
    private boolean bRootWRL = false;
    public static boolean bCloseState = false;
	private int iBrowserCt = 0;
    private String sDefaultWorldA = ( "Group { " +
        "children [ " +
        "Background { skyColor [.3 .3 1, .5 .5 1 ] skyAngle [ 1.57 ] groundColor [ .7 .4 .1, .7 .6 .3 ] groundAngle [ 1.57 ] } " +
        "Transform { " +
        "translation 0 0 -15 " +
        "children [ " +
        "Billboard { " +
        "children [	" +
        "Shape { " +
        "geometry Text { string [");
    private String sDefaultWorldB = "]  }  } ]}]}]}"; 
    private int iHeartRate = 7;
    private int iHRcnt = 0;
    private static int iSClose = 0;
    private static boolean bSClose = true;
    private Browser browser;
    private boolean bFailedURL = false;
    private boolean bTransit = true;
    private boolean bStart = true;
    private boolean bStart2 = true;
    private int iStart = 0;
	private boolean bStart3 = true;
    private int iAtmps = 0;
    private int iTransit = 9;
    private boolean bDisconnect = false;
    /**
    * New 11-12-05 updateOk is to determine if VRML plugin has begin and end update methods from later EAI
    */
    public boolean updateOk = false;
    /**
    * New 11-12-05 bNet status is determined in run to indicate if Network is connected to send heart beat. 
    */
    public boolean bNet = false;
	private Node switchNode = null;
    private EventInSFInt32 hide = null;
    /**
    * EAI stuff
    * New 11-12-05 scrpNode holds a new Script Node found in the root world named "SCRP"
    * This script appears to do nothing, but in fact is very important because it enables
    * the heart beat thread to get caught up with the VRML browser by making the EventInSFBool 
    * "addBool" true. See below    
    */
    private Node scrpNode = null;
    /**
    * EAI stuff
    * New 11-12-05 addBool is gotten from scrpNode Script Node ( see above ) It is set true
    * just before a heart beat is sent over network. 
    */
    private EventInSFBool addBool = null;
    private EventInSFInt32 setWI = null;
   /**
    * EAI stuff
    * rooNode is the main Grouping Node to which contains all the added worlds, avatars and objects.
    * The three EventInMFNode and one EventOutMFNode below it control the VRML comings and goings. 
    */
    private Node [] rootNode = null;
    private Node [] WIF = null;
   /**
    * EAI stuff
    * Belongs to rootNode.
    * All VRML from the createVRMLfromURL call except the Room name VRML is added here at the run method.
    * 
    */
    private EventInMFNode addChildren = null;
	private EventInMFNode addChildren2 = null;
   /**
    * EAI stuff
    * Belongs to rootNode.
    * All VRML from the createVRMLfromURL call except the Room name VRML is removed here at the reset method.
    * 
    */
    private EventInMFNode removeChildren = null;
    private EventInMFNode removeChildren2 = null;
    /**
    * EAI stuff
    * Belongs to rootNode.
    * The Room name VRML is added here at the run method. 
    */
    private EventInMFNode setChildren = null;
	private EventInMFNode setChildren2 = null;
   /**
    * EAI stuff
    * Belongs to rootNode.
    * Used in reset method to get list of VRML Nodes actually added to the room, so they can be removed.
    */
    private EventOutMFNode childrenChanged = null;
    private EventOutMFNode childrenChanged2 = null; 

    
    private String sFailedURL =	("Transform {  " +  
             "translation 	0 0 0 " + 
             "children [	Shape {  " +
             "appearance	NULL  " + 
             "geometry	 IndexedFaceSet {  " + 
             "coord	Coordinate {  " + 
	            " point	[ -0.25 1.75 0.125, "  +
		  " -0.25 0.0 0.125,"  +
		  " 0.25 1.75 0.125, "  +
		  " 0.25 0.0 0.125, "  +
		  " 0.25 1.75 -0.125, "  +
		  " 0.25 0.0 -0.125, "  +
		  " -0.25 1.75 -0.125, "  +
		  " -0.25 0.0 -0.125 ] "  +
     "  } "  +
     " coordIndex	[ 0, 1, 3, 2, -1, 4, 5, 7, "  +
	       "  6, -1, 6, 7, 1, 0, -1, 2, "  +
	       "  3, 5, 4, -1, 6, 0, 2, 4, "  +
	       "  -1, 1, 7, 5, 3, -1 ] "  +
             "color Color { color [ .3 .3 .3, .3 .3 .3, .3 .3 .3, .3 .3 .3, .3 .3 .3, .3 .3 .3, .3 .3 .3,  .3 .3 .3 ]}  " +  
             "}}]}  " );

   
	private String sVendor;
    private String sOSname;
    private String sOSarch;
    private String sOSversion;
	private static String sShutdown;


    /**
     * Viewer interface stuff
     */
    private Vector listeners = new Vector();
    // other things
    private String worldName;

    private String userName;

    private Thread runner;

       /**
     * Indicates LoadObserver instance is finished and not to repeat.
     */

 private boolean loadFlag = false;

	/**
     * VRML object loaded successfully if true.
     */

  private boolean bSuccess = true;

  /**
   *   SO2 in loaded -- run()        --> places SO2 in "objects" Hashtable below.
   */

    Vector loaded = new Vector(1);

   /**
    * SO2 in objects -- removeObject --> removes SO2 from world & objects
    */

     Hashtable objects = new Hashtable();



 
 /**
   * New 3-11-08 Constructor for standalone InstantPlayer -reworked FreeWRL code. 
  */
 
    public EAIViewer() {
       nullifyRootVRML();        
	}

   	 public EAIViewer( String sV, String sOS, String sArch, String sVersion, String sShutdown, String slocalHost_IP, int iPort ) {
   sVendor = sV; sOSname = sOS; sOSarch = sArch; sOSversion = sVersion; this.sShutdown = sShutdown; this.slocalHost_IP = slocalHost_IP; this.iPort = iPort;
   System.out.println("EAIViewer slocalHost_IP: " +  slocalHost_IP + " on port: " + iPort );
   int [] ints = new int[4];
   int iR = 0;
   int iCt = 0;
   String sBy = null;
   try {
   for( int i = 0; i<slocalHost_IP.length();i +=1 ){
   if(slocalHost_IP.charAt(i)=='.'){
   ints[iCt] = Integer.parseInt( slocalHost_IP.substring(iR, i) );
   //System.out.println(ints[iCt]);
   iR = (i+1);
   iCt += 1;
    }
   if(i==(slocalHost_IP.length()-1)){
   ints[iCt] = Integer.parseInt( slocalHost_IP.substring(iR) );
   //System.out.println("iCt: " + iCt + " ints[iCt]: " + ints[iCt]);
   }
   }
   }
   catch(NumberFormatException e){ System.out.println( "EAIViewer: " + e ); return;}
   for(int j = 0; j<ints.length; j +=1 ){
   bylocalHost_IP[j] = (byte)ints[j];
       }
   start();    
	}

    public Browser getBrowser(){
	return browser;
    }
  

  private void getRoot(){
Node Foo = null;
     try { 
     switchNode = browser.getNode("SW");
     }
  catch(NullPointerException g){ System.out.println( "Root Node failure: " + g);
  return;}
  catch(InvalidNodeException d){ System.out.println( "Root Node failure: " + d);
  return;} 
  catch(InvalidVrmlException f){ System.out.println( "Root Node failure: " + f);
  return;} 

     try {
     hide = (EventInSFInt32)switchNode.getEventIn("whichChoice");
     rootNode = ((EventOutMFNode)switchNode.getEventOut("children")).getValue();
	 addChildren = (EventInMFNode)rootNode[0].getEventIn("addChildren");
	 removeChildren = (EventInMFNode)rootNode[0].getEventIn("removeChildren");
	 setChildren = (EventInMFNode)rootNode[0].getEventIn("set_children");
	 childrenChanged = (EventOutMFNode)rootNode[0].getEventOut("children_changed");
      }
  catch(NullPointerException g){ System.out.println( "Root Node failure: " + g);
  return;}
  catch(InvalidNodeException d){ System.out.println( "Root Node failure: " + d);
  return;} 
  catch(InvalidVrmlException f){ System.out.println( "Root Node failure: " + f);
  return;} 
  catch (InvalidEventInException ei) {
     System.out.println( "Root EventIn exception: "+ ei);
    return;
      }
     catch (InvalidEventOutException ou) {
     System.out.println( "Root EventOut exception: "+ ou);
    return;
      }
  catch(Exception e){ System.out.println( "Root Node failure: " + e);
  return;}
       try {
       scrpNode = browser.getNode("SCRP");
        }
    catch(InvalidNodeException d){ System.out.println( "Script Node failure: " + d);
    return;} 
    catch(InvalidVrmlException f){ System.out.println( "Script Node failure: " + f);
    return;} 
    catch(NullPointerException g){ System.out.println( "Script Node failure: " + g);
    return;} 
      catch(Exception e){ System.out.println( "Script Node failure: " + e ); 
    return;}
         try {
       addBool = (EventInSFBool)scrpNode.getEventIn("heartBeat");
          }
  	  catch(NullPointerException g){
         System.out.println( "SCRP NullPointerException EventIn: "+ g);
         return;
          }
          catch (InvalidEventInException ei2) {
       System.out.println( "SCRP -heartBeat or set_WI: "+ ei2);
          return;
          }
	  

      }

 /**
  * New 11-12-05 Originally called in the Beta applet's start method.
  * Moved to handleRoom_A and only called at the very first room.
  */

  void start(){
    if(runner==null){
	runner = new Thread( this,"Viewer_Heart" );
	runner.start();
     }
    }

  /**
    * Called at Beta applet stop. 
    */ 

    public void stop(){
	runner = null;
    }

 // &&viewernum!=2


 public void run(){
 SO2 object;
	while( Thread.currentThread() == runner  ){  
if(bTransit){
// System.out.println("EAIViewer run bTransit true ");
  if(iTransit==0){
	  lSleep = 500;
      networkConsumers( true );
      reset();
	  setiTransit( 1 ); 
     }        
  else 
 if(iTransit==1){
 //System.out.println("EAIViewer run bTransit true iTransit 1 ");
    closeBrowser();
  nullifyRootVRML(); 
    setiTransit( 2 );
   }
 else 
 if(iTransit==2){
 iStart = 0;
if(bDisconnect){
browserControl( 7 );
 }
else {
 browserControl( 6 );
 browserControl( 1 );
  }
 setiTransit( 3 ); 
 }
  else 
  if(iTransit==3){
 lSleep = 500;
 if(iStart==0&&iAtmps<5){
 if(bDisconnect){
browserControl( 7 );
 }
else {
 browserControl( 6 );
 browserControl( 1 );
  }
  iAtmps += 1;
 }
 else {
 browserControl( 13 );
 iAtmps = 0;
 setiTransit( 4 );
    }
   }
 else 
   if(iTransit==4){
 if(iStart<2&&iAtmps<5){
   browserControl( 13 );
    iAtmps += 1;
 }
 else {
   iAtmps = 0;
  if(bDisconnect){
 networkConsumers( false );
 setbTransit( false );
 }
  else {
 browserControl( 2 );
  lSleep = 1000;
 setiTransit( 14 );
	  }
    }
  }
 else
 if(iTransit==14){
 browserControl( 3 );
  iStart = 0;
 setiTransit( 5 );
 }
  else 
 if(iTransit==5||iTransit==9){
//System.out.println("EAIViewer run iTransit 5 or 9");
 iBrowserCt = 0;
if(iTransit==5){ browserControl( 4 );
// System.out.println("EAIViewer run iTransit 5");
 setiTransit( 12 );
  }
 else {
//System.out.println("EAIViewer run iTransit 9 a");
browserControl( 5 );
//System.out.println("EAIViewer run iTransit 9 b");
 setiTransit( 13 ); 
    }
  }
 else 
 if(iTransit==12||iTransit==13){
 if(iStart==0&&iAtmps<5){
  if(iTransit==12){ 
 setiTransit( 5 ); 
 }
 else {
 setiTransit( 9 );
  }
 iAtmps +=1; 
  }
 else {
 browserControl( 12 );
 iAtmps = 0;
 if(iTransit==12){
 // System.out.println("EAIViewer run iTransit 12");
 setiTransit( 6 );
 }
 else {
 // System.out.println("EAIViewer run iTransit 13 a");
 setiTransit( 7 );
   }
  }
 }
 else 
 if(iTransit==6||iTransit==7){
 if(iStart<2&&iAtmps<5){ 
 if(iTransit==7){ 
 setiTransit( 13 ); 
 }
 else {
 setiTransit( 12 );
  }
iAtmps +=1; 
 }
 else {
  lSleep = 500;
//System.out.println("EAIViewer run iTransit 6 or 7 ");
 if(iBrowserCt<45){
   try {
   InetAddress	address = null;
   address = InetAddress.getByAddress(bylocalHost_IP);
   //System.out.println("InetAddress: " + address.toString() );
	browser = BrowserFactory.getBrowser(address, iPort);
    }
  catch( UnknownHostException h ){ browserControl( 9 ); System.out.println("InvalidHostException getting browser try count: " + iBrowserCt + " " + h ); iBrowserCt = 45; setbTransit( false ); } 
  catch( ConnectionException e ){  System.out.println("Trying to connect to browser: " + iBrowserCt + " " + e ); 
 if(iBrowserCt%7==0){ browserControl(10);}
  try{
	System.out.println("connect sleep: " + lSleep );
		runner.sleep( lSleep );
	    }
	 catch( InterruptedException j ){}
  }
  catch( InvalidBrowserException f ){ browserControl( 9 ); System.out.println("InvalidBrowserException getting browser try count: " + iBrowserCt + " " + f); iBrowserCt = 45; setbTransit( false ); }
  catch( NullPointerException g ){ browserControl( 9 ); System.out.println( "NullPointerException getting browser try count: " + iBrowserCt + " " + g);iBrowserCt = 45; setbTransit( false );}
  if (browser != null){
  	System.out.println("Browser achieved!");
     browser.addBrowserListener(new BrowserListener() {

                public void browserChanged(BrowserEvent evt)
                {
                    onBrowserChanged(evt);
                }

            });
   getRoot();
 if(!bStart){ browserControl( 8 ); }
 else{  
 String name = browser.getName().toLowerCase();
 if( name.indexOf("freewrl") >= 0||name.indexOf("avalon") >= 0 ){updateOk = true; viewernum = 2; System.out.println( name + " updateOk: "+ updateOk );}
 bStart = false; 
 }
  lSleep = 1000;
  iAtmps = 0;
  setiTransit( 0 );
  iBrowserCt = 45;
  setbTransit( false );
  } 
  else { iBrowserCt += 1; }
   }
  else { browserControl( 9 ); setbTransit( false ); }
  }
 }
else 
if(iTransit==10){
 System.out.println( "Run iTransit 10" );
 browserControl( 8 ); 
  bStart2 = false;
  setiTransit( 0 );
  setbTransit( false );
  }
}
else {
// System.out.println("bTransit1 is false");  
 try {
if( !loaded.isEmpty() ){ 
// System.out.println("bTransit2 is false");
	  	object = (SO2)loaded.elementAt(0);	   
     if( object.getName().equals( worldName )){
  //setSwitch(0);
		 Node [] foo = new Node [] { object.getTransform() };
		 System.out.println("bTransit4 is false");
       //iNodeCt = ((EventOutMFNode)foo[0].getEventOut("children_changed")).size(); 
	 if(0<((EventOutMFNode)foo[0].getEventOut("children_changed")).size() ){
           objects.put( object.getName(), object );
			onWorldLoaded( object.getName(), object );
			worldName = null; bWorld = false;
		    } 
           }
         else {
        if(bWorld){
             resetSystem();
        }
         else {
          Node [] foo2 = object.getTransforms1(); 
          int iAvSize = ((EventOutMFNode)foo2[0].getEventOut("children_changed")).size();
		   if(0<iAvSize){
			objects.put( object.getName(), object );
            iNodeCt = iNodeCt + iAvSize;
			onObjectLoaded( object.getName(), object );
               }
			 }
		    } 
 		  } 
  if(bNet==true){ 
   setHeartBeatCount();
   }
 }
catch(NullPointerException npe){
 }
}
     try{
		runner.sleep( lSleep );
	    }
	 catch( InterruptedException e ){}
    }
}

 public synchronized void setbFailedURL( boolean tf ){
 bFailedURL = tf;
 }

 public synchronized void setiTransit( int num ){
 iTransit = num;
 }

 public synchronized void setbTransit( boolean tf ){
 bTransit = tf;
 }

 /**
  * New 11-12-05 setHeartBeatCount sends the heart beat every seven seconds over the network by watching the global variable integer "cnt" (a counter).
  * There maybe a better way to do this.
  */
 void setHeartBeatCount(){
 if(iHeartRate<=iHRcnt){
 if(addBool!=null){ addBool.setValue(true); }
  onHeartBeat();
  iHRcnt = 0;
  }
 else {
  iHRcnt += 1;
  }
 }

 public void setSwitch( int choose ){
 if(hide!=null){ hide.setValue(choose);}
  else { System.out.println("whichChoice of SW is NULL!"); }
 }

 public void setUserName( String nm ){
 userName = nm;
 }

 public void setiStart( int iStr ){
 iStart = iStr;
 }
 
 public void setbStart3(){
 bStart3 = false;
 }

 public static  void setbSClose(){
if(bSClose){ 
setiSClose( 0 );
bSClose = false; 
}
else { 
bSClose = true;
}
// System.out.println("EAIViewer called2 setbSClose now: " + bSClose );
 }  

 private static synchronized  void setiSClose( int iC ){
 iSClose = iC;
 } 

 public void resetLoaded(){ 
 loaded.removeAllElements();
 }

 public void resetAvLoaded( SO2 obj ){ 
 if(loaded.contains(obj)){
 loaded.removeElement(obj);
//System.out.println("resetAvLoaded2 loaded contains obj size: " + loaded.size() );
}
else {
System.out.println("resetAvLoaded3 loaded does not contain obj size: " + loaded.size() );
}
 }

  /**
     * New 11-12-05 "goodbye" node created in the constructor is added 
     * to stop a NullPointerException in WorldView for those that care.
     * reset call created to differentiate it from the delete call which
     * nullifies the Browser and all VRML when the window finally closes.
     */


  public void reset(){
 if( childrenChanged2!=null&&0<childrenChanged2.size() ){ 
    removeChildren2.setValue( childrenChanged2.getValue() );
   // System.out.println( "reset: 0<childrenChanged2.size() " );
  }  
 if( childrenChanged!=null&&0<childrenChanged.size() ){   
  removeChildren.setValue( childrenChanged.getValue() ); 
  // System.out.println( "reset: 0<childrenChanged.size() " );
  }
    loaded.removeAllElements();
	objects.clear();
 }


    public void viewerDisconnect( int ct ){ 
  System.out.println("viewerDisconnect ct: " + ct );
   if(ct==0){ 
      bDisconnect = true;
     setiTransit( 0 );
    } 
   else  
   if(ct==1){
     bDisconnect = false;
     setiTransit( 0 ); 
	 }
   else    
   if(ct==2){
	 bDisconnect = false;
    if(!bStart2){    
    setiTransit( 9 );
     }
    else { 
   setiTransit( 10 );
     }
    }
  else 
   if(ct==3){
   bDisconnect = false;
    setiTransit( 10 );
    }
    setbTransit( true );
    }

 private void nullifyRootVRML(){
   addChildren2 = null;
   removeChildren2 = null;
   setChildren2 = null;
   childrenChanged2 = null;
   addChildren = null;
   removeChildren = null;
   setChildren = null;
   childrenChanged = null;
   addBool = null;
   switchNode = null;
   rootNode = null;
   hide = null;
   scrpNode = null;
   iNodeCt = 0;
   iStart = 0;
   bStart3 = true;
   } 
 
 private void closeBrowser(){
   if(browser!=null){ 
      // System.out.println("Close Browser");
          browser.removeBrowserListener( new BrowserListener() {

                public void browserChanged(BrowserEvent evt)
                {
                    onBrowserChanged(evt);
                }

            }); 
       browser.dispose(); 
  // System.out.println("closeBrowser");
	   browser = null;
      }
 }
 
 

  private void reloadRoot( String st ){
  String [] MFfoo = {st};
  String [] MFfoo2 = {""}; 
  if(browser!=null){
    try {
    browser.loadURL(MFfoo,MFfoo2);
     }
   catch( Exception e){ System.out.println( "Root failed to load! "); }
     } 
else { System.out.println( "browser is null");}
System.out.println("EAIViewer reloadRoot called");
       }
 
    // Viewer Interface start -------------------------------------------------------


   /**
     * New 11-12-05 putSO method is a callback from the Beta applet load a VRML file
     * into the objects hashtable. Previously a VRML file was loaded directly in EAIViewer
     * in the run method. This addition is to needed to find out if the VRML file previously
     * exists or not! See "onObjectLoaded" and "onWorldLoaded" methods in Beta class.   
     */


    /**
     * loads the world as background. Will also return a SharedObject
     * but might need some more initialization.  
     */

    public void loadWorld( String name, String url ){
  System.out.println("EAIviwer: loadWorld name: " + name + " url " + url );
	worldName = name;
    bWorld = true;
	addSharedObject( name, url );
    }

 private void backUpAvatar( Node [] foo ){
 Node[] help3 = null;
	  try {
	 help3 = browser.createVrmlFromString( sFailedURL );
      }
  catch (InvalidVrmlException g) { System.out.println(" backUpAvatar Invalid VRML prob: " + g );
  return; } 
catch (InvalidNodeException d) { System.out.println(" backUpAvatar Node prob: " + d );  
  return; }
catch(InvalidBrowserException e){ System.out.println( " backUpAvatar Browser prob: " + e ); }
catch(NullPointerException f){System.out.println(" backUpAvatar Null prob: " + f );
  return; }
  ((EventInMFNode)foo[0].getEventIn("addChildren")).setValue(help3);
 }

 private void backUpWorld( Node [] foo, String ex ){
 Node[] help3 = null;
	  try {
	 help3 = browser.createVrmlFromString( sDefaultWorldA + ex + sDefaultWorldB  );
      }
  catch (InvalidVrmlException g) { System.out.println("defaultWorld Invalid VRML prob: " + g );
  return; } 
catch (InvalidNodeException d) { System.out.println("defaultWorld Node prob: " + d );  
  return; }
catch(InvalidBrowserException e){ System.out.println( "defaultWorld Browser prob: " + e ); }
catch(NullPointerException f){System.out.println("defaultWorld Null prob: " + f );
  return; }
  ((EventInMFNode)foo[0].getEventIn("addChildren")).setValue(help3);
 }

 public void addUserAvatar( String name, String url ){
String stg = "";
Node[] help2 = null;
Node[] help = null;
if( name.equals( userName )){
//System.out.println("EAIViewer addUserAvatar username 1");
                           stg = ("PROTO Avatar2 [ " +
						   "exposedField SFVec3f translation 0 0 0 "+
						   "exposedField SFVec3f hud_translation 0 0 0 "+
						   "exposedField SFRotation rotation 0 1 0 0 "+
                           "eventIn MFNode addChildren " +
						   "eventIn MFNode removeChildren " +
						   "exposedField MFNode children_changed [] " +
                           "eventIn MFNode name_tag " +
						   "exposedField SFInt32 which 0 " + 
                           " ] " +
						   "{ " +
                           "Group { "+
                           "children [ "+
                           "Switch { whichChoice IS which "+
						   "choice [ " +
                           "Group { " +
                           "children [ " +
						   "Transform { " +
                           "translation IS translation " +
                            "addChildren IS name_tag " +
						   " } " +
						   "Group { " +   
                           "children [ " +
						   "Transform { " +
                           "translation IS translation " +
						   "rotation IS rotation " +    
						   "children [ " +
						   "Group { " +   
                           "children [ " +
						   "Transform { " +
                           "translation IS hud_translation " +
						   "rotation 0 1 0 3.141 " +
						   "removeChildren IS removeChildren " +
						   "addChildren IS addChildren " +
						   "children IS children_changed " +
						   "}, " +
                           "]} " +
                           "]}]}]}]}]}" + 
                           " } " +
                           "Avatar2 {} " +
    					   "Viewpoint {} ");
                            }
    else { 
//System.out.println("EAIViewer addUserAvatar Drone url: " + url);
         stg = ("PROTO Avatar3 [  " +
			 "exposedField SFVec3f translation 0 0 0  " +
			 "exposedField SFRotation rotation 0 1 0 0 " +
             "exposedField SFInt32 whichChoice 0 " +
			 "exposedField MFFloat range [40, 80] " +   
             "eventIn MFNode addChildren " +
    		 "eventIn MFNode addTXTChildren " +
             "eventIn MFNode removeChildren " +
			 "exposedField MFNode children_changed [] " +   
             "] " +
			 "{ " +  
			 "Group { " +
             "children [ " +
             "Switch { " +
             "whichChoice IS whichChoice " +
             "choice [ " +
             "Group { " + 
			 "children [ " + 
			 "Transform { " +
             "translation IS translation " +
             "addChildren IS addTXTChildren " +
             " } " +
             "Group { " +
             "children [ " +
             "Transform { " + 
             "translation IS translation " +  
             "rotation IS rotation " +  
             "children [ " +     
             "Group { " +   
             "children [ " + 
             " LOD { " + 
             "range IS range " +   
             " level [ " + 
			 "Group { " +   
             "children " +
             "Transform { " +
			 "rotation 0 1 0 3.141 " +
             "addChildren IS addChildren " +
             "removeChildren IS removeChildren " +
			 "children IS children_changed " +  
             "  } } " + 
    		 "Group { " +   
             "children [ " +
             "Transform {  " +  
             "translation 	0 0 0 " + 
             "children [	Shape {  " +
             "appearance	NULL  " + 
             "geometry	 IndexedFaceSet {  " + 
             "coord	Coordinate {  " + 
	            " point	[ -0.25 1.75 0.125, "  +
		  " -0.25 0.0 0.125,"  +
		  " 0.25 1.75 0.125, "  +
		  " 0.25 0.0 0.125, "  +
		  " 0.25 1.75 -0.125, "  +
		  " 0.25 0.0 -0.125, "  +
		  " -0.25 1.75 -0.125, "  +
		  " -0.25 0.0 -0.125 ] "  +
     "  } "  +
     " coordIndex	[ 0, 1, 3, 2, -1, 4, 5, 7, "  +
	       "  6, -1, 6, 7, 1, 0, -1, 2, "  +
	       "  3, 5, 4, -1, 6, 0, 2, 4, "  +
	       "  -1, 1, 7, 5, 3, -1 ] "  +
             "color Color { color [ .3 .3 .3, .3 .3 .3, .3 .3 .3, .3 .3 .3, .3 .3 .3, .3 .3 .3, .3 .3 .3,  .3 .3 .3 ]}  " +  
             "}}]}]}  " + 
             "Group { } " + 
             "      ]} " + 
             "    ]} " +
             "   ]} " +
			 "  ]} " +
    		 " ]} " +
             "]} " +
			 "]} " +
			 "} " +
			 "Avatar3 {} "); }
 try {
help = browser.createVrmlFromString( stg );	 
      }
catch (InvalidVrmlException g) { System.out.println("addUserAvatar help cVFS Invalid VRML prob: " + g );
  return; } 
catch (InvalidNodeException d) { System.out.println("addUserAvatar help cVFS Node prob: " + d );  
  return; }
catch(InvalidBrowserException e){ System.out.println( "addUserAvatar help cVFS  Browser prob: " + e ); 
 return;}
catch(NullPointerException f){System.out.println("addUserAvatar help Null cVFS prob: " + f );
  return; }

try {
help2 = browser.createVrmlFromString( "Group {}" );	 
 }
catch (InvalidVrmlException g) { System.out.println("addUserAvatar help2 cVFS Invalid VRML prob: " + g );
  return; } 
catch (InvalidNodeException d) { System.out.println("addUserAvatar help2 cVFS Node prob: " + d );  
  return; }
catch(InvalidBrowserException e){ System.out.println( "addUserAvatar help2 cVFS Browser prob: " + e ); }
catch(NullPointerException f){System.out.println("addUserAvatar help2 Null cVFS prob: " + f );
  return; }

   try {
	browser.createVrmlFromURL( new String[] { url }, help2[0], "addChildren");
     }
  catch(InvalidBrowserException h){ 
  System.out.println( "addUserAvatar help2 cVFU failed: " + h );return;}
  catch(URLUnavailableException e){	
  System.out.println( "addUserAvatar help2 cVFU failed: " + e );
  return;
   }
  catch(InvalidURLException f){ 
  System.out.println( "addUserAvatar help2 cVFU failed: " + f );
  backUpAvatar( help2 );
    }
  catch(InvalidVrmlException g){ 
  System.out.println( "addUserAvatar help2 cVFU failed: " + g );
  backUpAvatar( help2 );
   }
  catch(NullPointerException j){ 
   System.out.println( "addUserAvatar help2 cVFU failed: " + j );
  return;
   }
  catch(Exception l){ System.out.println( "addUserAvatar help2 cVFU failed: " + l );
  return;
   }
     addChildren2.setValue( help );
   ((EventInMFNode)help[0].getEventIn("addChildren")).setValue( help2 );
   SO2 object = new SO2( name, url, help2, help );
   loaded.insertElementAt( object, 0 );
  } 

    /**
     * loads a SharedObject into the simulation. Identified by a name.
     * New 11-12-05 This adds a work around for WorldView VRML plugin
     * The grouping Node [] help has to be added to the Root node BEFORE  
     * the observer can tell if it succeeds. See run method above for the anti-thesis.
     *  
     */

    public void addSharedObject( String name, String url ){
Node[] help = null;
Node[] help2 = null;
if(browser!=null){
 try {
help = browser.createVrmlFromString( "Group {}" );	 
}
catch (InvalidVrmlException g) { System.out.println("World help Invalid VRML prob: " + g );
  return; } 
catch (InvalidNodeException d) { System.out.println("World help Node prob: " + d );  
  return; }
catch(InvalidBrowserException e){ System.out.println( "World help Browser prob: " + e ); }
catch(NullPointerException f){System.out.println("World help Null prob: " + f );
  return; }
  catch(Exception e){ System.out.println( "World help Node failure: " + e);
  return;}	
  try {
	browser.createVrmlFromURL( new String[] { url }, help[0], "addChildren");
 }
  catch(InvalidBrowserException h){System.out.println( "cVFU failed: " + h );return;}
  catch(URLUnavailableException e){ System.out.println( "cVFU failed: " + e );return;}
  catch(InvalidURLException f){ System.out.println( "cVFU failed: " + f );
   backUpWorld( help, "\"Invalid url for world\"" );
    }
  catch(InvalidVrmlException g){  System.out.println( "cVFU failed: " + g );
   backUpWorld( help, "\"World has bad VRML code!\"" );
   }
  catch(NullPointerException j){ System.out.println( "cVFU failed: " + j );return;}
  catch(Exception l){ System.out.println( "cVFU failed: " + l ); return; }
 SO2 object = new SO2( name, help[0] );
 loaded.insertElementAt( object, 0 );
 addChildren.setValue( help  );
 addChildren2 = (EventInMFNode)help[0].getEventIn("addChildren");
 childrenChanged2 = (EventOutMFNode)help[0].getEventOut("children_changed");
 setChildren2 = (EventInMFNode)help[0].getEventIn("set_children");
 removeChildren2 = (EventInMFNode)help[0].getEventIn("removeChildren");
  } 
 else { System.out.println( "VRML Browser is NULL!" ); }
 }

	      

    /**
     * removes the SharedObject identified by name.
     */

    public void removeSharedObject( String name ){
	   	SO2 object = (SO2)objects.remove( name );
	if( object != null ){
		removeChildren2.setValue(  object.getTransforms2()  );
	  }
    }

    public void removeSharedObject2( SO object ){
    SO2 obj2 = (SO2)object;
	 Node [] foo2 = obj2.getTransforms2(); 
        removeChildren2.setValue(foo2);
    }


    // adding / removing ViewerListener

    /**
     * adds a ViewerListener for callbacks on successful loading.
     */
    public void addViewerListener( ViewerListener listener ){
	if( ! listeners.contains( listener ))
	    listeners.addElement( listener );
    }

    /**
     * removes a ViewerListener
     */

    public void removeViewerListener( ViewerListener listener ){
	listeners.removeElement( listener );
    }

   /**
     * New 11-12-05 beginUpdate method has been modified
     * so that which browser is ascertained before the method is actually
     * called.
     * This was necessary so Cosmoplayer would not throw nullpointer exception 
     * in I.E. 
     * See RealTimeHandler for use.
     */

    public void beginUpdate(){
	    browser.beginUpdate();
    }

    /**
     * New 11-12-05 endUpdate method has been modified
     * so that which browser is ascertained before the method is actually
     * called
     * This was necessary so Cosmoplayer would not throw nullpointer exception 
     * in I.E. 
     * See RealTimeHandler for use.
     */

    public void endUpdate(){
	    browser.endUpdate();
    }

   // Viewer Interface end ---------------------------------------------------------

   /**
     * New 11-12-05 getViewernum method VRML plugin indentification by integer.
     */

 public int getViewernum(){
 return(viewernum);}


    // helper functions for  calling listeners
    /**
     * New 11-12-05 Sets boolean bNet.
     */

  public void setbNet( boolean tf ){
  bNet = tf;
System.out.println("EAIViewer bNet: " + bNet );
  }

  public void setiHeartRate( int ihr ){
   iHeartRate = ihr;
  }

  public int getiHeartRate(){
   return iHeartRate;
  }


  private void resetSystem(){
   Enumeration list = listeners.elements();
     while( list.hasMoreElements()){
   ((ViewerListener)list.nextElement()).resetSystem();
     } 
  }


    // helper functions for  calling listeners
   private void networkConsumers( boolean tf ){
   Enumeration list = listeners.elements();
  while( list.hasMoreElements()){
   ((ViewerListener)list.nextElement()).networkConsumers( tf );
     } 
  } 
    
   private void browserAchieved( boolean tf ){
   Enumeration list = listeners.elements();
  while( list.hasMoreElements()){
   ((ViewerListener)list.nextElement()).browserAchieved(tf);
     } 
   }

  
 //  private void onReset(){
 //  Enumeration list = listeners.elements();
 // while( list.hasMoreElements()){
 //  ((ViewerListener)list.nextElement()).onReset();
 //    } 
 //  } 

  

   private void browserControl( int iCt){
	   Enumeration list = listeners.elements();
  while( list.hasMoreElements()){
   ((ViewerListener)list.nextElement()).browserControl( iCt );
     } 
   }

      /**
     * New 11-12-05 Sends hear beat to Beta to poll server
     */

   private void onHeartBeat(){
   Enumeration list = listeners.elements();
  while( list.hasMoreElements()){
   ((ViewerListener)list.nextElement()).onHeartBeat();
     } 
  } 
  
    private void onWorldLoaded( String name, SharedObject object ){
	Enumeration list = listeners.elements();
	while( list.hasMoreElements()){
	    ((ViewerListener)list.nextElement()).onWorldLoaded( name, object );
	}
    }

    private void onObjectLoaded( String name, SharedObject object ){
	Enumeration list = listeners.elements();
	while( list.hasMoreElements()){
	    ((ViewerListener)list.nextElement()).onObjectLoaded( name, object );
	}
    }

  private static void onBrowserChanged(BrowserEvent evt)
{
  switch (evt.getID())
  {
 case BrowserEvent.INITIALIZED:
    break;
 case  BrowserEvent.SHUTDOWN: 
System.out.println( "BrowserEvent: shutdown");
    break;
 case  BrowserEvent.URL_ERROR:
	   System.out.println( "BrowserEvent: URL_ERROR");
	 //System.exit(0);
  break;
 case BrowserEvent.CONNECTION_ERROR:
System.out.println( "BrowserEvent: Connection_error");
  System.gc();
  System.runFinalization();
    if(bSClose){
// System.out.println("onBrowserChanged Connection error bSClose is true");
  System.exit(0);
    }
   else {
// System.out.println("onBrowserChanged Connection error bSClose is false");
 if(iSClose==0){ 
//  System.out.println("onBrowserChanged Connection error iSClose is 0");
  setiSClose( 1 ); 
   }
 else {
 // System.out.println("onBrowserChanged Connection error iSClose is 1");
  System.exit(0); 
   }
   }
  break;
  default:
      System.out.println("BrowserEvent: " + evt);
  }
}

public void delete(){
    reset();
    runner = null;
  closeBrowser();
  }
}
