/**
  MatrixSound.java

Copyright (C) 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9. 
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * This file also uses code from JavaZOOM : jlgui@javazoom.net
 *  http://www.javazoom.net
 * It is also under the GNU General Public License described above
 *
 */  

package matrix.deck.eai2;
import javazoom.jlgui.basicplayer.*;
import java.util.*;
import java.net.URL;
import java.net.MalformedURLException;
import java.net.URLEncoder;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import matrix.vrml.*;
import matrix.vrml.eai2.*;
import vrml.eai.*;
import vrml.eai.field.*;
import vrml.eai.event.*;

public class MatrixSound implements VrmlEventListener, BasicPlayerListener, Runnable {
    private	BasicPlayer player;
		// BasicPlayer is a BasicController.
	private	BasicController control;
		// Register BasicPlayerTest to BasicPlayerListener events.
		// It means that this object will be notified on BasicPlayer
		// events such as : opened(...), progress(...), stateUpdated(...)
    private Node MS = null;
    private EventOutMFFloat Parameter_cmds;
	private EventOutSFRotation Player_cmds;
    private String [] URLs; 
    private int iUrlCt = 0;
    private float fHalf = 0.0f;
    private float fFrDist = 0.0f;
	private float fBckDist = 0.0f;
    private float fVar1 = 1.0f;
	private float fVar2 = 1.0f;
	private float fVar3 = 1.0f;
    private float fVar4 = 1.0f;
    private float fVar5 = 1.0f;
    private float fMidSqRt1 = 0.0f;
    private float fMidSqRt2 = 0.0f;
    private float fBackBound2 = 0.0f;
    private float fFrtCubeRt = 0.0f; 
    private float fBkCubeRt = 0.0f;
    private float fFrontVar = 0.0f;
    private float fBackVar = 0.0f;
    private float fAdjMxFront = 0.0f;
    private float fAdjMxBack = 0.0f;
    private float fmaxFront = 0.0f;
	private float fmaxBack = 0.0f;
    private float fminFront = 0.0f;
	private float fminBack = 0.0f;
    private float fFrAdd = 0.0f;
    private float fBkAdd = 0.0f;
    private float fFrontBound = 0.0f;
    private boolean bFrontBound = false;
    private float fBackBound = 0.0f;
    private boolean bBackBound = false;
    private float fNewLoc [] = { 0.0f, 0.0f, 0.0f, 0.0f, 0.0f };
    private String [] AU = null;
    private EventOutMFString AudioUrl = null;
    private EventInSFInt32 PlayerState	= null;
    private EventInSFBool SetDirection = null;
    private Vector vCmds = new Vector();
    private Float FCmd [] = new Float [4];
    private double dVol = 0.0, dVol2 = 0.0, dPitch = 1.0;
    private boolean bKill = false;
    private boolean bReady = false;
    private boolean bInner = false;
    private boolean bLoop = false;
    private boolean bChange = false, bChange2 = true, bChange3 = true;
    private boolean bPlay = false;
    private Thread runner = null;
    private boolean bSpatialize = false;
    
    public MatrixSound( Node msnd, int vS )	throws RuntimeException {
        MS = msnd;
	    runner = new Thread( this, ("MS_"+ vS) );
	    runner.start();
    }

 private void setSoundVariables(){
    if(fmaxBack==fmaxFront&&fminBack==fminFront&&fmaxBack==fminBack&&fmaxFront==fminFront){
        dVol2 = dVol;
      }
       else {
		fFrDist = fmaxFront-fminFront;
        fBckDist = fmaxBack-fminBack;
		fHalf = ((fmaxBack + fmaxFront)/2);
     if((fmaxBack+fminFront)<fHalf){
        fFrontBound = (fHalf - (fmaxBack + fminFront))*-1;
	//  System.out.println("1 fFrontBound: " + fFrontBound );
        }
        else {
    	fFrontBound = (fHalf-(fmaxFront - fminFront));
    // System.out.println("2 fFrontBound: " + fFrontBound );
        }
        if((fmaxFront+fminBack)<fHalf){
        fBackBound = (fHalf - (fmaxFront + fminBack));		
	// System.out.println("3  fBackBound: " + fBackBound ); 
        }
        else {
		fBackBound = (fHalf-(fmaxBack-fminBack))*-1; 
   	// System.out.println("4 fBackBound: " + fBackBound );
        }
  fAdjMxFront = fmaxFront*(fHalf/fmaxFront);
  System.out.println("fAdjMxFront: " + fAdjMxFront );
  fAdjMxBack = fmaxBack*(fHalf/fmaxBack);
  System.out.println("fAdjMxBack: " + fAdjMxBack );
  float fmB = (fmaxBack*fmaxBack);
  fMidSqRt1 = (fBckDist*fBckDist);
  fMidSqRt2 = (fBckDist*fmaxBack);
  fFrtCubeRt = (fFrDist*fmB);
  fBkCubeRt = (fBckDist*fmB);
  }
	System.out.println("fHalf: " + fHalf );
	System.out.println("fFrontBound: " + fFrontBound + " fBackBound: " + fBackBound );
	System.out.println("fFrDist: " + fFrDist + " fBckDist: " + fBckDist );
    System.out.println(" fmxF: " +  fmaxFront + " fmxB: " + fmaxBack + " fmnF: " +  fminFront + " fmnB: " + fminBack  );
 }

    public void run(){
    	try {
        SetDirection = (EventInSFBool)MS.getEventIn("set_bdirection");
        PlayerState = (EventInSFInt32)MS.getEventIn("player_state");
     	dVol = new Float( ((EventOutSFFloat)MS.getEventOut("intensity")).getValue() ).doubleValue();
	    fmaxFront = Math.abs( ((EventOutSFFloat)MS.getEventOut("maxFront")).getValue() );
		fmaxBack =	Math.abs( ((EventOutSFFloat)MS.getEventOut("maxBack")).getValue() );
        fminFront = Math.abs( ((EventOutSFFloat)MS.getEventOut("minFront")).getValue() );
        fminBack = Math.abs( ((EventOutSFFloat)MS.getEventOut("minBack")).getValue() );
        float fP = ((EventOutSFFloat)MS.getEventOut("pitch")).getValue();
        if(0.0<fP){
		dPitch = new Float( fP ).doubleValue();
        }
	   setSoundVariables();
        setLoop( ((EventOutSFBool)MS.getEventOut("loop")).getValue() );
        AudioUrl =	(EventOutMFString)MS.getEventOut("audio_url");
        URLs = AudioUrl.getValue();   	
        for( int iS = 0; iS<URLs.length; iS += 1 ){
            URLs[iS] = URLs[iS].replaceAll(" ","%20");
        }
		Player_cmds = ((EventOutSFRotation)MS.getEventOut("player_commands"));
        Player_cmds.addVrmlEventListener(this);
        Parameter_cmds = ((EventOutMFFloat)MS.getEventOut("parameter_commands"));
		Parameter_cmds.addVrmlEventListener(this);
        }
catch(RuntimeException h){ System.out.println("MatrixSound " + runner.getName() + " error: " + h); runner = null; return; }
catch(Exception e){ System.out.println("MatrixSound " + runner.getName() + " error: " + e); runner = null; return; }
        player = new BasicPlayer();
        control = (BasicController) player;
		player.addBasicPlayerListener(this);
 BasicPlayerControl( 1 );
       if(dPitch!=1.0){
 BasicPlayerControl( 8 ); 
 }
  if( getLoop() ){
  BasicPlayerControl( 2 );
 if(getPlay()){ 
  BasicPlayerControl( 6 );
  BasicPlayerControl( 7 );
     }
  }
    bReady = true;
	SetDirection.setValue( true );
	while( Thread.currentThread() == runner ) {
    synchronized(vCmds){
   if(!vCmds.isEmpty()){
   Float [] FCmds = (Float[])vCmds.firstElement();
   int iCmd = FCmds[0].intValue();
//  System.out.println("MS running iCmd: " + iCmd );
   switch(iCmd){
    case 1:
    if(getPlay()&&!bInner){
 //  System.out.println("case 1 bPlay!" );
   fNewLoc[0] = Math.abs( FCmds[1].floatValue() );
   fNewLoc[1] = Math.abs( FCmds[2].floatValue() );
   fNewLoc[2] = Math.abs( FCmds[3].floatValue() );
   fNewLoc[3] =	FCmds[3].floatValue();
 // System.out.println(" case 1 fNL: " + fNewLoc[0] + " " + fNewLoc[1] + " " + fNewLoc[2] + " fNewLoc[3]: " + fNewLoc[3] );
  float fD = 0.0f;
  float fD2 = 0.0f;
  if(fNewLoc[3]<fFrontBound){
  if(fBackBound<fNewLoc[3]){
	float fY = fmaxBack-fNewLoc[1];
    float fX = fmaxBack-fNewLoc[0];
    fD =  (fY*fX);
    fD2 = fMidSqRt2;
//	 System.out.println("Middle fD: " + fD + " fD2: " + fD2 + " fY: " + fY );
     } 
  else {
	float fZ = 0.0f;
    if(fNewLoc[3]<0){ fZ = fAdjMxBack-fNewLoc[2]; }
    else { fZ = fHalf+fNewLoc[2]; }
    float fY = fmaxBack-fNewLoc[1];
    float fX = fmaxBack-fNewLoc[0];
    fD =  (fZ*fY*fX);
	fD2 = fBkCubeRt;
   // bTail = true;
//	System.out.println("Back line1 fmaxBack: " + fmaxBack + " fBckDist: " + fBckDist   );
//	System.out.println("Back line2 fD: " + fD + " fD2: " + fD2 + " fX: " + fX + " fY: "  + fY + " fZ: " + fZ  );
    }
   }
   else {
	float fZ = 0.0f;
    if(0<fNewLoc[3]){ fZ = fAdjMxFront-fNewLoc[2];	}
    else { fZ = fHalf+fNewLoc[2]; }
    float fY = fmaxBack-fNewLoc[1];
    float fX = fmaxBack-fNewLoc[0];
    fD =  (fZ*fY*fX);
	fD2 = fFrtCubeRt;
 //   System.out.println("Front line1 fmaxFront: " + fmaxFront + " fminFront: " + fminFront + " fFrDist: " + fFrDist   );
 //  System.out.println("Front line2 fD: " + fD + " fD2: " + fD2 + " fX: " + fX + " fY: "  + fY + " fZ: " + fZ  );
        }
if(fD!=0.0&&fD2!=0.0){ 
 float fG = (fD/fD2);
// System.out.println("Result1: fD: " + fD + " fD2: " + fD2 + " fG: " + fG ); 
  //fG = 1.0f-(fD/fD2);
 dVol2 = dVol*( new Float( fG ).doubleValue() );
// System.out.println("Result2 dVol2: " + dVol2 + " new fG: " + fG );
if(dVol<dVol2){ dVol2 = dVol; }
if(dVol2<0){ dVol2 = 0.0; }
 BasicPlayerControl( 6 );
  }
 }
   break;
    case 2:
   if(getLoop()){
  BasicPlayerControl( 4 );
   }
 else {
  BasicPlayerControl( 2 );
    }
  BasicPlayerControl( 6 ); 
   break;
    case 3:
   BasicPlayerControl( 3 );
    break;	
    case 4:
   BasicPlayerControl( 4 );	
	break;
    case 5:
   dVol2 = 0.0;	
   setPlay( false );
if(getLoop()){
 BasicPlayerControl( 3 );	
   }
 else {
 BasicPlayerControl( 5 ); 
    }
	break;
    case 6:
   setLoop( true );
	break;
    case 7:
   setLoop( false );
	break;
    case 8:
   fmaxFront = Math.abs( FCmds[1].floatValue() );
   fmaxBack = Math.abs( FCmds[2].floatValue() );
   fminFront = Math.abs( FCmds[3].floatValue() );
   fminBack = Math.abs( FCmds[4].floatValue() );
   setSoundVariables();
   SetDirection.setValue( true );
	break;
    case 12:
   dVol = FCmds[1].doubleValue();
   if(dVol<=dVol2){
     dVol2 = dVol;
    }
   else {
     dVol2 = (dVol2/dVol);
    }
   if(dVol2<0.0){ dVol2 = 0.0; }
	BasicPlayerControl( 6 );
	break;
    case 13:
    if(FCmds[1].floatValue()==1.0){ 
  // System.out.println("MatrixSound 13 1 " + URLs[iUrlCt] );
    bInner = true;
    if(!getLoop()){
 //  System.out.println("MatrixSound 13 1 getLoop==false and play" );
    BasicPlayerControl( 2 );
    }
    dVol2 = dVol; 
    BasicPlayerControl( 6 );
     }
    else { bInner = false;
      if(!getLoop()){
    BasicPlayerControl( 2 );
    }
      else {
 if(FCmds[2].floatValue()==1.0){ 
	dVol2 = 0.0; 
    BasicPlayerControl( 6 );
           }
         }
      }
	break;
    case 14:
    if( getPlay()&&0.0<FCmds[1].doubleValue() ){
	dPitch = FCmds[1].doubleValue(); 
    BasicPlayerControl( 8 );
     } 
    break;
    case 15:
  boolean bLoopRs = false;
  iUrlCt = 0;
  if( getLoop() ){ 
   bLoopRs = true;
   setLoop( false );
   }
  if( getPlay() ){
   BasicPlayerControl( 5 );
   }
  URLs = AudioUrl.getValue();   	
  for( int iS = 0; iS<URLs.length; iS += 1 ){
  URLs[iS] = URLs[iS].replaceAll(" ","%20");
        }
// System.out.println("MatrixSound 15 " + URLs[iUrlCt] );
 BasicPlayerControl( 1 );
 if( bLoopRs ){
 setLoop( true );
 BasicPlayerControl( 2 );
  }
    break;
    }
   vCmds.removeElementAt(0);
   try{
		vCmds.wait();
	    }
	    catch(InterruptedException e){}
      }
    else {
   if(bKill) { 
   setLoop( false );
  // System.out.println( "Stopping sound" ) ;
   BasicPlayerControl( 5 );
   runner = null; 
   }
   else {
      try{
		vCmds.wait();
	    }
	    catch(InterruptedException e){}
         }
        }
       }
	 }
    }

    public void eventOutChanged(VrmlEvent vrmlevent) {
	if( !bReady ) return;
  Float [] FLt = null;
  float [] flt = null;
    BaseField bf =  vrmlevent.getSource();
     if( bf.getType()==BaseField.SFRotation ) {
   flt = Player_cmds.getValue();
   }
  if( bf.getType()==BaseField.MFFloat ) {
  flt = Parameter_cmds.getValue();
   }
// System.out.println("eventOutChanged: MFFloat");
  FLt = new Float[flt.length];
 for( int ct = 0; ct<flt.length; ct++){
  FLt[ct] = new Float(flt[ct]);
    }
  addCommands( FLt );
   }
 
   private void addCommands( Float [] cmds ){
   synchronized(vCmds){
   vCmds.addElement( cmds );
   vCmds.notify();
     }
    }

 private synchronized void setPlay( boolean tf ){
 bPlay = tf;
 }

 private synchronized boolean getPlay(){
 return bPlay;
 } 

 private synchronized void setLoop( boolean tf ){
 bLoop = tf;
 }

 private synchronized boolean getLoop(){
 return bLoop;
 }  

 public void opened(Object stream, Map properties ){
 }

    /**
     * Progress callback while playing.
     * 
     * This method is called severals time per seconds while playing.
     * properties map includes audio format features such as
     * instant bitrate, microseconds position, current frame number, ... 
     * 
     * @param bytesread from encoded stream.
     * @param microseconds elapsed (<b>reseted after a seek !</b>).
     * @param pcmdata PCM samples.
     * @param properties audio stream parameters.
     */
    public void progress(int bytesread, long microseconds, byte[] pcmdata, Map properties ){
    }

    /**
     * Notification callback for basicplayer events such as opened, eom ...
     *  
     * @param event
     */
    public void stateUpdated( BasicPlayerEvent event){
        int iCode = event.getCode(); 
		PlayerState.setValue( iCode ); 
	  	if (getLoop()&&iCode==BasicPlayerEvent.STOPPED)
		{
		 BasicPlayerControl( 2 );
		 BasicPlayerControl( 6 );
		}

  
    }

    /**
     * A handle to the BasicPlayer, plugins may control the player through
     * the controller (play, stop, ...)
     * @param controller : a handle to the player
     */
    public void setController(BasicController controller){
    }

   private synchronized void BasicPlayerControl( int iCtrl ){
        try {
        	switch(iCtrl){
            case 1:
            if(URLs[iUrlCt]!=null){ 
          if(!URLs[iUrlCt].startsWith("http://")){
			control.open(new File(URLs[iUrlCt]));
           }
          else {
          if(URLs[iUrlCt].endsWith(".mp3")){
			control.open(new URL(URLs[iUrlCt]));
           }
          else {
            control.open( new FileInputStream( URLs[iUrlCt])  );
             }
            }
          }
            break;
            case 2: 
			control.play(); 
        	setPlay( true );
            break;     
            case 3:
			control.pause();
            break;
            case 4:
			control.resume();
			setPlay( true );
            break;
            case 5:
			control.stop();
            break;
            case 6:
			control.setGain( dVol2 );
            break;
            case 7:
			control.setPan( 0.0 );
            break;
			case 8:
            control.setRate( dPitch );
		  }	
		}
		catch (BasicPlayerException e)
		{  
         String sEr	= e.toString();
    	 System.out.println( sEr );
 if( (sEr.indexOf("Rate not supported")==-1)&&(sEr.indexOf("Gain control not supported")==-1)&&(sEr.indexOf("Pan control not supported")==-1)&&(sEr.indexOf("Skip not supported")==-1) ){
        setPlay( false );
        if((sEr.indexOf("FileNotFoundException"))!=-1&&(iUrlCt<(URLs.length-1))){
		  iUrlCt += 1;
          BasicPlayerControl( 1 );
		  BasicPlayerControl( 2 );
          BasicPlayerControl( 6 );
         }
          else {
          System.out.println( "MatrixSound error: " + runner.getName() +  e );
           try {
            delete();
             }
          catch(RuntimeException f){
    		System.out.println( "MatrixSound error: " + f );
               }
              }
            return;
             }
          else 
           return;
			}
		 catch( FileNotFoundException h ){
		 System.out.println( "MatrixSound error: " + runner.getName() +  h );
		         try {
            delete();
             }
           catch(RuntimeException f){
    		System.out.println( "MatrixSound error: " + f );
             }
            }
         catch (MalformedURLException g ){
		         try {
            delete();
             }
          
          catch(RuntimeException f){
    		System.out.println( "MatrixSound error: " + f );
             }
           return;
         }
    }

    public void delete() throws RuntimeException {

if(Player_cmds!=null){ Player_cmds.removeVrmlEventListener(this); Player_cmds = null; }
if(Parameter_cmds!=null){ Parameter_cmds.removeVrmlEventListener(this); Parameter_cmds = null; }
 bKill = true;
 synchronized(vCmds){
  vCmds.removeAllElements();
  vCmds.notify();
    } 
 // System.gc();
 // System.runFinalization();
    }
  }
