/** 
 MatrixVRMLLauncher.java

 * Copyright (C) 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9. 
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * This file also uses open-source code of BrowserLauncher2 : 
 * Copyright 2004,2005,2006,2007 Markus Gebhard, Jeff Chapman
 * http://browserlaunch2.sourceforge.net/
 *
 * BrowserLauncher2 is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 */

package matrix.deck.eai2;

import java.util.*;
import java.io.*;

public class MatrixVRMLLauncher implements Runnable {

  private String sOpen;
  private String sClose;
  private Process child = null;
  private String sCMD;
  private errorProcess EP;
  private Thread runner = null;
  private boolean bOpen = true;
	


 private class errorProcess implements Runnable {

 private Process errorChild;
 private Thread errorRunner = null;

 errorProcess( Process pc ){
 errorChild = pc;
 start();
 } 


 void start(){
 if(errorRunner == null ){ 
  errorRunner = new Thread(this,"EP"); 
  errorRunner.start(); }
  }
   
  void stop(){
  errorRunner = null;
 if(errorChild!=null){ errorChild.destroy(); }
  errorChild = null;
  }

  public void run(){
     try {
 if(errorChild!=null){ 
 BufferedReader er = new BufferedReader( new InputStreamReader( errorChild.getErrorStream() ) );
     String sError = null;
	 while ((sError = er.readLine()) != null) {   
                System.out.println(sError);   
            }  
	errorChild.waitFor(); // wait for process to exit safely	 
               }
			} 
        catch (Exception err) { // uh-oh
				err.printStackTrace(); // tell me what exploded
			}
            }
   }

  public MatrixVRMLLauncher( String sOPEN, String sCLOSE ){
 sOpen = sOPEN;
 sClose = sCLOSE;
  }	

 public void setOpen(){ 
 stop();
 bOpen = true;
 sCMD = sOpen;
 start();
 }

 public void setOpen2(){
 }

 public void setClose(){
 stop();
 bOpen = false;
 sCMD = sClose;
 start();
 }

  public void stopEP(){
 if(EP!=null){ EP.stop(); }
 }

    public void start(){
 if(runner == null ){
  runner = new Thread(this,"MVL"); 
  runner.start(); }
  }
   
  public void stop(){
  runner = null;
  if(child!=null){ child.destroy();
// System.out.println("MVL stopped"); 
  }
  child = null;
  }

	public void run(){
	  try {
 child = Runtime.getRuntime().exec(sCMD); 
 BufferedReader in = new BufferedReader( new InputStreamReader( child.getInputStream() ) ); 
 if(bOpen){  EP = new errorProcess( child ); }
            String line = null;   
            while ((line = in.readLine()) != null) {   
           System.out.println( line );  
            }  
 if(child!=null){	child.waitFor(); } // wait for process to exit safely	 
			} 
        catch (InterruptedException e ){}
        catch (Exception err) { // uh-oh
				err.printStackTrace(); // tell me what exploded
			}
		//	System.out.println("RunCommand \""+sCMD+"\" complete.");

     }

 }
