 /**
  Rot_PosObserver.java

 Copyright (C) 1999 Geometrek	and 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */


package matrix.deck.eai2;
import matrix.vrml.*;
import matrix.vrml.eai2.*;
import vrml.eai.*;
import vrml.eai.field.*;
import vrml.eai.event.*;

public class Rot_PosObserver implements VrmlEventListener {
 public boolean show = false;
 public boolean dead = false;
 public boolean bProxy = false;
 private boolean bEL = false;
 private boolean posChanged = false;
 //private EventInSFBool resetPrx;
 private EventOutSFVec3f pos_out;
 private boolean bTest = false;
 private SFVec3f offset = new SFVec3f((float)0.0,(float)-1.85,(float)0.0);
 //private float [] tp1 = { 0.0f, 1000.0f, 0.0f };
 //private float [] tp2 = { 0.0f, 1000.0f, 0.0f };
 private float [] tp3 =	{ 0.0f, 0.0f, 0.0f };
 private SFVec3f pos2 = new SFVec3f( 0, 0, 0 );
 private SFVec3f ghostpos = new SFVec3f( 0, 0, 0 );
 private boolean notnow = false;

 private  boolean rotChanged = false;
 private EventOutSFRotation rot_out;
 private SFRotation rot2 = new SFRotation(0, 1, 0, 0);

    public Rot_PosObserver( EventOutSFRotation prox_rot, EventOutSFVec3f prox_pos ) throws Exception {
 //    resetPrx = RP;
	 rot_out = prox_rot;
  rot_out.addVrmlEventListener(this);
  pos_out = prox_pos;
 pos_out.addVrmlEventListener(this);
  bEL = true;
     }

	public void eventOutChanged( VrmlEvent vrmlevent ) {
  	if( show == true || dead == true )
	    return;
  BaseField bf =  vrmlevent.getSource();
		if( bf.getType()==7 ) {
   rot2 = new SFRotation(rot_out.getValue());
   bProxy = false;
   set_rotChanged( true ); 
		}
	 if( bf.getType()==11 ) {
   tp3 = pos_out.getValue();
   pos2 = offset.plus( new SFVec3f(tp3) );
   bProxy = false;
   set_posChanged( true ); 
    }
	  else
    return;
   }

public void setOffset( SFVec3f sfv ){
 offset = sfv;
 }

//public void resetProxy( boolean tf ){
//if(resetPrx!=null){ resetPrx.setValue(tf); }
//}

public synchronized void set_posChanged( boolean tf ){
posChanged = tf;
}

public boolean get_posChanged(){
return posChanged;
}

public SFVec3f positionReturn(){
return pos2 ;}

public SFVec3f positionGhost(){
ghostpos = new SFVec3f(pos_out.getValue());
return ghostpos; }

public synchronized void set_rotChanged( boolean tf ){
rotChanged = tf;
}

public boolean get_rotChanged(){
return rotChanged;
}

public SFRotation initRot(){
SFRotation initRot = new SFRotation(rot_out.getValue());
return initRot;
} 

public SFRotation orientationReturn(){
return rot2;}


public void delete(){
  pos_out.removeVrmlEventListener(this);
  rot_out.removeVrmlEventListener(this);
  bEL = false; 
  set_posChanged( false );
  set_rotChanged( false );	 
    }
}