/*
  WorldSendChat.java

  Copyright (C) 2009 by R. Russell Kinter
 
 *  This file is part of DeepMatrixIP9.
 *
 *  DeepMatrixIP9 is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  DeepMatrix IP9 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */









package matrix.deck.eai2;

import matrix.vrml.*;
import matrix.deck.*;
import java.io.*;
import java.util.*;
import vrml.eai.*;
import vrml.eai.field.*;
import vrml.eai.event.*;

/**
 * New 11-12-05 WorldSendChat sends chat messages from world to network chat via the Beta class.
 * Instanced by WorldObject class.
 * @version 0.1    
 * @author Russ Kinter
 */

public class WorldSendLocalChat extends WorldSendChat {


  public  WorldSendLocalChat(Beta beta, Node WSC ){  
  super.deck = beta; 
  super.wsc = WSC; 
  super.chat = (EventOutMFString)wsc.getEventOut("to_chat");
  super.chat.addVrmlEventListener(this);
  super.runner = new Thread( this,"Yak_To_Local_Chat" );
  super.runner.start();
}

  public  WorldSendLocalChat(Beta beta, EventOutMFString eomfs ){  
  super.deck = beta;  
  super.chat = eomfs;
  super.chat.addVrmlEventListener(this);
  super.runner = new Thread( this,"Yak_To_Local_Chat" );
  super.runner.start();
}

  public WorldSendLocalChat(){
}

  /**
     *  New 11-12-05 sendChat is called by run once a second ( wait(1000) if the Vector "vec" still
     *  contains Strings. If it doesn't, it goes to sleep ( wait() ) till waken up by callback - the eventOut observer 
     */

 protected void sendLocalChat() throws InterruptedException {
    synchronized(vec) { 
       if(!vec.isEmpty()){
       String st2 = vec.firstElement().toString();
       deck.handleChat3( st2,"Matrix" );
       vec.removeElementAt(0);
       vec.wait(1000);
        }
    else { 
      vec.wait();
      }
    }
  }

 public void run(){
    try { 
     holdChat();
      }
    catch(InterruptedException e){}
  while( Thread.currentThread() == runner ) {
 try {
    sendLocalChat();
   } 
 catch(InterruptedException e){}
 
  }
}
  

    /**
     *  New 11-12-05 clean up at either disconnect or room change. 
     *  Notifying the Vector being used as a buffer at clean up was used in the original
     *  DeepMatrix (Connection inner class MessageBuffer ) and therefore adopted here as well. 
     */

  public void delete(){ 
   super.delete();
   } 
}