/*
  BotConsumer.java

  Copyright (c) 1998 Gerhard Reitmayr
*/

package tools;

import matrix.deck.Network;
import matrix.deck.RealTimeConsumer;
import matrix.deck.ConsumerException;

/**
 * This interface must be implemented by any classes that should work in a Bot. The Bot
 * class uses this interface to set data and start / stop etc. the class
 *
 * @version 0.1
 * @author Gerhard Reitmayr
 */
public interface BotConsumer extends RealTimeConsumer {

/**
 * initializes the object with its arguments and gives it a handle to the
 * network backend. Its up to the object to deal with them. It even has to register itself
 * with the network backend if it wishes to do so.
 */
  public void setData( Network network,  String[] args ) throws ConsumerException ;

/**
 * starts any own functionality or thread. this is usually called if the network is up
 * and running
 */
  public void start();

/**
 * stops the consumer. the consumer should also free any resources now and can be discared
 * after a stop. ( it works like start / stop for threads ) This would be called typically
 * before the connection is closed.
 */
  public void stop();
  public void beamto( String target );

}


