/**
  QuadBot3.java

  Copyright (C) 1998 Gerhard Reitmayr  && 20009 by Russ Kinter
*/

package tools;

import matrix.RealTimeMessage;
import matrix.Message;
import matrix.vrml.*;
import matrix.deck.*;
import java.io.*;

/**
 * A Bot that travels in a rectangle. It is based on RotBot class by Gerhard Reitmayr.
 * 
 * QuadBot3 by Russ Kinter
 *
 */
public class QuadBot3 implements BotConsumer, Runnable {
  private String name, url;
  private Thread runner;
  private Network postOffice;
  private long pause;
  private float dst = 1.0f;
  private float[] rot ={0.0f, 1.0f, 0.0f, 0.0f};
  private float [] ft = { 1.0f, -1.0f};
  private float[] pos = {3.0f, 1.5f, 100.0f};
  private float wth = pos[0];
  private float lng = pos[2];
  private boolean bAvatar = false;
  public QuadBot3(){
  }

  public void setData( Network network, String[] args) throws ConsumerException {  
   postOffice = network;
   float w2;
   float l2;
   float j2;
   float h2;
   if( args.length != 7 ) {
    throw new ConsumerException("args error"); }
    else {
    name = args[0];
  System.out.print(name+" data");
    url = args[1];
    try{
      pause = Long.valueOf( args[2] ).longValue();
     }
    catch( NumberFormatException e ){
      throw new ConsumerException("Sleep interval not a number");
    }
     try{ w2 = Long.valueOf( args[3] ).floatValue(); }
    catch( NumberFormatException e ){
     throw new ConsumerException("Bot walk width not a number");
    }
    if(w2%2==0){wth = pos[0] = w2/2;} else {System.out.println("Width is not even number! Default value of 3 meters will be used!");}
    try{ l2 = Long.valueOf( args[4] ).floatValue(); }
   catch( NumberFormatException e ){
    throw new ConsumerException("Bot walk length not a number");
   }
   if(l2%2==0){lng = pos[2] = l2/2;} else { System.out.println("length is not even number! Default value of 100 meters will be used!");}
   try{ h2 = Float.valueOf( args[5] ).floatValue();
     pos[1] = h2;
  System.out.println("h2: " + h2 );
     }
    catch( NumberFormatException e ){
     throw new ConsumerException("Bot Y height pos[1] not a number");
    }
      try{j2 = Long.valueOf( args[6] ).floatValue(); }
   catch( NumberFormatException e ){
     throw new ConsumerException("Bot walk width not a number"); }
  if((((l2/j2)%2)==0)&&(((w2/j2)%2)==0)){
   dst = j2; } else {  System.out.println("Bot jump distance does not make even number! Default value of 1 meter will be used!");}
   }}

  public String getName(){
    return name;
  }

  public void handleMessage( String tag, Field data ) throws ConsumerException {
    if(!tag.equals(name))
      throw new ConsumerException(name+" matches not "+tag);
    System.out.print(name+".");
  }

  public void update(){try { postOffice.sendRealTime( RealTimeMessage.NONE, name, new SFRotation( rot ), false ); }
    catch(IOException e){System.out.println("No connection");}
 }

  public void objectRoutes( String obj ){
 }

 public void userView( String uv ){
  }

 public boolean getbAvatar(){
 return bAvatar;
 }

  public void beamto(String target){
 } 

  public void setUserPosition( float [] sUP ){
 }

  public void checkPosition( float[] fUP, boolean bUPs  ){
  }

  public void start(){
    try {
      postOffice.addSharedObject( name, url );
    }
	catch(InterruptedException f){}
    catch(IOException e){
      System.err.println(name+" error adding me "+e);
      return;
    }
    postOffice.addConsumer( this );

    runner = new Thread( this, name );
    runner.start();

    System.out.println("QuadBot3 "+name+" started");
  }

  public void stop(){
    runner = null;
    postOffice.removeConsumer( name );
    try {
      postOffice.deleteSharedObject( name );
    }
    catch(InterruptedException f){}
    catch(IOException e){
      System.err.println(name+" error deleting me "+e);
      return;
    }System.out.println("QuadBot3 stop");
  }

  public void delete(){
  }
  public void run() {
   int a = 0;
  System.out.println( "run" );
    while( Thread.currentThread() == runner ){ 
   if(wth==pos[0]&&-lng<pos[2]){ pos[2]  -= dst;}
   if(pos[2]==-lng&&wth==pos[0]){  rot[1] = ft[0]; rot[3] = 1.57f; a = 1;} 
   if(pos[2]==-lng&&-wth<pos[0]){ pos[0] -= dst; }
   if(pos[2]==-lng&&-wth==pos[0]){  rot[1] = ft[0]; rot[3] = 3.14f;a = 1;} 
   if(pos[0]==-wth&&pos[2]<lng){ pos[2]  += dst; }
   if(pos[2]==lng&&-wth==pos[0]){ rot[1] = ft[1]; rot[3] = 1.57f; a = 1;}
   if(pos[2]==lng&&pos[0]<wth){ pos[0] += dst; }
   if(pos[2]==lng&&wth==pos[0]){ rot[1] = ft[0]; rot[3] = 0.0f; a = 1;}
   try { 
        postOffice.sendRealTime( RealTimeMessage.NONE,  name, new SFVec3f( pos ), false ); 
        if(a==1){postOffice.sendRealTime( RealTimeMessage.NONE, name, new SFRotation( rot ), false ); a = 0;}
       runner.sleep( pause );
      }
      catch(NullPointerException f){ runner = null; System.out.println(name+" npe sending rtm\n\t"+f); System.exit( 0 ); return; }
      catch(Exception e){runner = null; System.out.println(name+" error sending rtm\n\t"+e); System.exit( 0 ); return; }
    }
  }
}
